/* Copyright Andy Mitchell 2007, 2008. No warranties */

function AutoLabel(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage
	this._doc = gtdinboxPage.doc;
	this._searchers = [];
	this._autoLabels = [];
}

AutoLabel.prototype.checkAutoLabel = function(){
	// Begin the auto label check process (after a message is sent)
	// Test their are items in settings to auto label (settings.autoLabel = [{to,subject,snippet}])
	// Load threads for today that I have sent (after:2008/05/02 from:me -chat)
	// Find threads in those that match the auto label items
try{

	
	if( !this._autoLabels || this._autoLabels.length==0 ) return;

	var d = (new Date()).valueOf();
	var minsAgo = d-(1000*60*15);
	for( var i = this._autoLabels.length - 1; i >= 0; i-- ){
		if( this._autoLabels[i].date < minsAgo ){
			this._autoLabels.splice(i,1);
		}
	}
	
	if( !this._autoLabels || this._autoLabels.length==0 ) return;
	
	
	
	var dayAgo = new Date(d-(1000*60*60*24));
	var weekAgo = d-(1000*60*60*24*7);
	var query = "after:" + dayAgo.getFullYear() + "/" + (dayAgo.getMonth() + 1) + "/" + dayAgo.getDate() + " from:me -chat";
	var labelsToRemove = {};
	
	
	var searcher = new Searcher(this._gtdinboxPage);
	searcher.search( query, GIPROTOTYPE.bind(this, function(threadList){
			try{
				var counter = {count:0};
				for( var i = 0; i < this._autoLabels.length; i++ ){
					var thread = threadList.getThreadByRow(this._autoLabels[i].subject, this._autoLabels[i].snippet, this._autoLabels[i].names, null, true);
					if( thread ){ // Add a label to the thread using a progmatic call
						labelsToRemove[this._autoLabels[i].date] = true;
						for( var j = 0; j < this._autoLabels[i].labels.length; j++ ){
							counter.count++;
							this._gtdinboxPage.gmailDOM.addLabelToThread( thread.id, this._autoLabels[i].labels[j], GIPROTOTYPE.bind(this, function(){
									counter.count--;
									if( counter.count==0 ){
										// Execute a refresh - all labels added.
										for( var k = this._autoLabels.length - 1; k>=0; k-- ){
											if( labelsToRemove[this._autoLabels[k].date] ){
												this._autoLabels.splice(k,1);
											}
										}
										setTimeout( GIPROTOTYPE.bind(this, function(){
											this._gtdinboxPage.refreshCurrentView();
										}), 500);
									}
								}), thread );
						}
					}
				}
			}catch(e){
				if( GTDDEBUGMODE ) alert("AutoLabel checkAutoLabel search\n" + e.toString());
			}
		}), 25);
	this._searchers.push(searcher);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("AutoLabel checkAutoLabel\n" + e.toString());
}

};

AutoLabel.prototype.addAutoLabel = function(nameStr, subjectStr, bodyStr, labels, initiate){
	if( !labels || labels.length==0 ) return;
	
	var autoLabel = {};
	autoLabel.subject = subjectStr;
	autoLabel.snippet = bodyStr.substr(0, 80);
	
	nameStr = nameStr.replace(";",",");
	var nameSplit = nameStr.split(",");
	var names = [];
	for( var i = 0; i < nameSplit.length; i++ ){
		var m = nameSplit[i].match(/\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i);
		if( m ){
			names.push([i,m[0]]);
		}
	}
	autoLabel.names = names;
	autoLabel.labels = labels;
	autoLabel.date = (new Date()).valueOf();
	
	this._autoLabels.push( autoLabel );
	
	if( initiate ){
		setTimeout( GIPROTOTYPE.bind(this, function(){
				this.checkAutoLabel();
			}), 10000);
	}
};

AutoLabel.prototype.destroy = function(){
	for( var i = 0; i < this._searchers.length; i++ ){
		this._searchers[i].destroy();
	}
	this._searchers.length = 0;
	this._gtdinboxPage = null;
};