function CacheStatuses(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._time = 120000;
	this._multiToOne = new MultiToOne(gtdinboxPage, this._time);
		this._multiToOne._timeLast = 0;
	this._eventHandlers = new GtdEventHandlers_Mutator(this);
	
	this.labelsWithStatus = {};	// this.labelsWithStatus["S/Next Action"] = {threads:, totalCount:, unreadCount:}
	this.threadList = null;
	//this._contactsWithStatus = {};	// this._contactsWithStatus["Contact"] = {threads:};
	
	this._lastRefresh = 0;
	//this._lastContactRefresh = 0;
	
	
	this._gtdinboxPage._threadList.addEventHandler(this, "addThreadLabel", this._addThreadLabel);
	this._gtdinboxPage._threadList.addEventHandler(this, "removeThreadLabel", this._removeThreadLabel);
}

CacheStatuses.prototype._addThreadLabel = function(o, d){
	// Add the label from this cache; be careful to instruct it not to broadcast again or it'll loop
	var labelname = d.labelname;
	var thread = d.thread;
	if( labelname && this.threadList ){
		var found = false;
		for( var i = 0; i < this.threadList._threads.length; i++ ){
			if( this.threadList._threads[i].id==thread.id ){
				this.threadList._threads[i].addLabel( labelname, null, null, true, null, true );
				found = true;
				break;
			}
		}
		if( !found ){
			this.threadList.addThread(thread);
		}
	}
	this._parseThreadListLabels();
	this._eventHandlers.broadcast("refreshed-labels");
	this.refreshLabels();	// queue us up for a proper refresh
};
CacheStatuses.prototype._removeThreadLabel = function(o, d){
	// Remove the label from this cache; be careful to instruct it not to broadcast again or it'll loop
	var labelname = d.labelname;
	var thread = d.thread;
	if( labelname && this.threadList ){
		for( var i = 0; i < this.threadList._threads.length; i++ ){
			if( this.threadList._threads[i].id==thread.id ){
				this.threadList._threads[i].removeLabel( labelname, null, null, true, null, true );
				break;
			}
		}
	}
	this._parseThreadListLabels();
	this._eventHandlers.broadcast("refreshed-labels");
	this.refreshLabels();	// queue us up for a proper refresh
};

CacheStatuses.prototype.refreshLabels = function(labels, forceRun){
try{
	// Try to queue it:
	var d = (new Date).valueOf();
	if( this._runOnce && !forceRun ){	// Activate rate limiting. If > 30 seconds since last run, run it immediately. Otherwise set up callback.
		if( (d-this._multiToOne._timeLast)>this._time ){	// More than 30 seconds. Run instantly.
			
		}else{
			this._multiToOne.process("refresh", GIPROTOTYPE.bind(this, function(){	// Pause for 30 seconds.
				this.refreshLabels(labels, true)}));
			return;
		}
	}
	this._multiToOne._timeLast = d;
	this._runOnce = true;
	
	this._lastRefresh = d;
	
	var status = this._gtdinboxPage.getStatusData();
	
	//if( !labels )	
	labels = this._gtdinboxPage._labels.getLabelsArray("Statuses"); // TODO Restore this so it only does the labels passed in. Why not right now? Because if we omit Action (because we know the result); ThreadList wipes it out below. Need to preserve what we do not change.
	
	var q = this._gtdinboxPage._labels.getLabelsQuery(null, null, [status.Finished], status.Finished, labels);
	
	
	
	if( !this._searcher ) this._searcher = new Searcher(this._gtdinboxPage);
	this._searcher.search(q, GIPROTOTYPE.bind(this, function(threadList){
		try{

			this.threadList = threadList;
			this._parseThreadListLabels();			
			this._eventHandlers.broadcast("refreshed-labels");
			this._eventHandlers.broadcast("refreshed-labels-server");
			
			
			
		}catch(e){
			if( GTDDEBUGMODE ) alert("CacheStatuses refreshLabels callback\n" + e.toString());
		}
	}));
}catch(e){
	if( GTDDEBUGMODE ) alert("CacheStatuses refreshLabels\n" + e.toString());
}
};

CacheStatuses.prototype._parseThreadListLabels = function(){
	var seenLabel = {};
	for( var i = 0; i < this.threadList._threads.length; i++ ){
		var thread = this.threadList._threads[i];
		for( var j = 0; j < thread.labels.length; j++ ){
			var l = thread.labels[j];
			
			if( !this.labelsWithStatus[l] ){
				this.labelsWithStatus[l] = {'threads':[], 'unreadCount':0};
				seenLabel[l] = true;
			}
			if( !seenLabel[l] ){
				this.labelsWithStatus[l].threads.length = 0;			
				seenLabel[l] = true;			
			}
			
			this.labelsWithStatus[l].threads.push( thread );
		}
	}
};

/*
CacheStatuses.prototype.getContacts = function(){
	// Ensure this is up to date before returning it
	
	if( this._lastContactRefresh < this._lastRefresh ){
		
		for( var i = 0; i < this._threadList.length; i++ ){
			var thread = this._threadList[i];
		}		
			
		this._lastContactRefresh = (new Date()).valueOf();
	}
	
	return this._contactsWithStatus;
};
*/


CacheStatuses.prototype.getThreadListByLabelOrContact = function(label, contact){
	// Return a cloned threadlist; restricted only to label or contact
	if( !this.threadList ) return new ThreadList(this._gtdinboxPage);
	
	var contactName = null;
	var contactEmail = null;
	if( contact ){
		if( /^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i.test(contact) ){
			contactEmail = GIPROTOTYPE.realEmail(contact);
		}else{
			contactName = contact;
		}
	}
	
	var threadList = this.threadList.clone();
	
	for( var i = threadList._threads.length - 1; i >=0; i-- ){
		var thread = threadList._threads[i];
		var keep = false;
		if( label ){
			for( var j = 0; j < thread.labels.length; j++ ){
				if( thread.labels[j]==label ){
					keep = true;
					break;
				}
			}
		}else{
			for( var j = 0; j < thread.names.length; j++ ){
				if( contactName ){
					if( thread.names[j][0]==contactName ){
						keep = true;
						break;
					}
				}else{
					if( thread.names[j][1]==contactEmail ){
						keep = true;
						break;
					}
				}
			}
		}
		if( !keep ){
			threadList._threads.splice(i, 1);
		}
	}
	
	return threadList;	
};

CacheStatuses.prototype.updateUnreadFromLabelBox = function(label, unreadCount){
try{
	if( !this.labelsWithStatus[label] )	this.labelsWithStatus[label] = {'threads':[], 'unreadCount':0};
	this.labelsWithStatus[label].unreadCount = unreadCount;
}catch(e){
	if( GTDDEBUGMODE ) alert("CacheStatuses refreshLabels\n" + e.toString());
}
};

