/* Copyright Andy Mitchell 2007, 2008. No warranties */


function FilterEnvironment(gtdinboxPage){
try{
	this._gtdinboxPage = gtdinboxPage;
	this._doc = this._gtdinboxPage.doc;
	this._eventObservers = new GtdEventObservers(this);
	this._eventHandlers = new GtdEventHandlers_Mutator(this);
	
	//this._eventObservers.observe( this._gtdinboxPage.gmailDOM.element("document").body, "contextmenu", this.contextMenu, true );
	this._eventObservers.observe( this._gtdinboxPage.gmailDOM.element("document").body, "mouseup", this.click, false );
	this._eventObservers.observe( this._gtdinboxPage.gmailDOM.element("document").body, "contextmenu", this.mouseDown, true );
	this._eventObservers.observe( this._gtdinboxPage.mainDoc.body, "contextmenu", this.stopEvent, true );
	this._eventObservers.observe( this._gtdinboxPage.mainDoc.body, "mouseup", this.mouseDown, true );
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterEnvironment constructor\n" + e.toString());
}
};


FilterEnvironment.prototype.createLabelPopup = function(labelName, el, search){
try{
	if( !this._gtdinboxPage._filterPopupUI && this._filterChild ){
		this._filterChild.destroy();
		this._filterChild = null;
	}

	var type = "Misc";
	if( labelName ){
		var types = this._gtdinboxPage.settings.labels.types;
		for( t in types ){
			if( labelName.indexOf(types[t].prefix)==0 ){
				type = t;
				break;
			}
		}	
	}else if( search ){
		type = "Search";
	}
	
	if( this._gtdinboxPage._filterPopupUI ){
		this._gtdinboxPage._filterPopupUI.refresh(labelName, type, true);
		this._filterChild = this._gtdinboxPage._filterPopupUI;
	}else{
		var parentSearch = el.getAttribute("gtdSearch");
		if( !parentSearch ) parentSearch = GIPROTOTYPE.searchableLabel(labelName);
		if( type=="Statuses" ){
			var statusFinished = this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished;
			var exclFinished = " -" + GIPROTOTYPE.searchableLabel(statusFinished);
			if( labelName!=statusFinished && parentSearch.indexOf(exclFinished)==-1 ) parentSearch += exclFinished;
		}
		this._filterChild = new FilterPopupUI( this._gtdinboxPage, labelName, type, el, [], [], parentSearch )
	}
	this._filterChild.popup(el,{location:'bottom', 'margin':5, scrollToView:true});	
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterEnvironment createLabelPopup\n" + e.toString());
}
};
FilterEnvironment.prototype.createContactPopup = function(name, email, el){
try{
	if( !this._gtdinboxPage._filterPopupUI && this._filterChild ){
		this._filterChild.destroy();
		this._filterChild = null;
	}

	if( this._gtdinboxPage._filterPopupUI ){
		this._gtdinboxPage._filterPopupUI.refresh( [name, email], "Contact", true );
		this._filterChild = this._gtdinboxPage._filterPopupUI;
	}else{
		var parentSearch = el.getAttribute("gtdSearch");
		if( !parentSearch ){
			parentSearch = "(";
			if( email ) parentSearch += "from:" + email + " OR to:" + email;
			if( name ) parentSearch += (parentSearch? " OR " : "") + "from:\"" + name + "\" OR to:\"" + name + "\"";
			parentSearch += ")";
		}
		this._filterChild = new FilterPopupUI( this._gtdinboxPage, [name,email], "Contact", el, [], [], parentSearch )
	}
	this._filterChild.popup(el,{location:'bottom', scrollToView:true});
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterEnvironment createContactPopup\n" + e.toString());
}
};

FilterEnvironment.prototype.viewChange = function(gmail){
try{
	if( this._elContactsBody ) return;
	
	
	// Extract the contacts body
	var onLoad = GIPROTOTYPE.bind(this, function(){
		if( this._elContactsBody ) return;
		this._elContactsBody = this._gtdinboxPage.gmailDOM.element("contacts-frame-body");
		if( this._elContactsBody ) this._eventObservers.observe( this._elContactsBody, "contextmenu", this.contextMenu, true );
		this._gtdinboxPage.addCSS(this._elContactsBody.ownerDocument);
	});	
	var found = false;
	var w = this._gtdinboxPage.gmailDOM.element("window");
	for( var i = 0; i < w.frames.length; i++ ){
		if( w.frames[i].location.href=="about:blank" ){
			this._eventObservers.observe( w.frames[i], "load", onLoad, false);
			found = true;
		}
	}
	if( !found ){	// Try old method:
		var w = this._gtdinboxPage.window.frames[1];
		for( var i = 0; i < w.frames.length; i++ ){
			if( w.frames[i].location.href=="about:blank" ){
				this._eventObservers.observe( w.frames[i], "load", onLoad, false);
				found = true;
			}
		}
	}
	/*
	var w = this._gtdinboxPage.window.frames[1];
	for( var i = 0; i < w.frames.length; i++ ){
		if( w.frames[i].location.href=="about:blank" ){
			var doc = w.frames[i].document;
			var onLoad = GIPROTOTYPE.bind(this, function(){
				if( this._elContactsBody ) return;
				this._elContactsBody = this._gtdinboxPage.gmailDOM.element("contacts-frame-body");
				if( this._elContactsBody ) this._eventObservers.observe( this._elContactsBody, "contextmenu", this.contextMenu, true );
				this._gtdinboxPage.addCSS(this._elContactsBody.ownerDocument);
			});
			this._eventObservers.observe( w.frames[i], "load", onLoad, false);
		}
	}
	*/	
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterEnvironment viewChange\n" + e.toString());
}	
};

FilterEnvironment.prototype.contextMenu = function(event){	// called in regular
	this._processClick(event);
};
FilterEnvironment.prototype.mouseDown = function(event){	// called in im
	var el = GIPROTOTYPE.element(event);
	if( event.button!=2 && !GIPROTOTYPE.hasClassName(el, "global-expander") ) return;
	this.stopEvent(event);
	this._processClick(event, el);
};
FilterEnvironment.prototype.click = function(event){
try{
	var el = GIPROTOTYPE.element(event);
	
	if( this._gtdinboxPage.gmailDOM.test("is-contact-more", el) ){
		var result = this._gtdinboxPage.gmailDOM.elements("contact-box-menu-items");
		var elEmail = this._gtdinboxPage.gmailDOM.element("contact-box-email");
		if( elEmail && result.snapshotLength>0 ){
			var elFirstItem = result.snapshotItem(0);
			if( !elFirstItem.firstChild || !elFirstItem.firstChild.getAttribute("gtd-contact-popup") ){
				var el = this._doc.createElement("DIV");
					el.className = "goog-menuitem gtd-contact-box-menuitem";
					el.setAttribute("role", "menuitem");
					el.innerHTML = "<div class='goog-menuitem-content' email='" + GIPROTOTYPE.stripTags(elEmail.innerHTML) + "' gtd-contact-popup='1'>" + this._gtdinboxPage.stringBundle.getString("ContactPopup.ContactBrowser") + "</div>";
				elFirstItem.parentNode.insertBefore( el, elFirstItem );
			}
		}
	}else if( el.getAttribute("gtd-contact-popup")=="1" ){
		this.createContactPopup( el.getAttribute("email"), el.getAttribute("email"), el );
	}
	
	this.stopEvent(event);
}catch(e){
	if( GTDDEBUGMODE ) alert("filterenvironment click\n" + e.toString());
}
};
FilterEnvironment.prototype.stopEvent = function(event){	// called in im
try{
	var el = GIPROTOTYPE.element(event);
	if( (event.button==2 || GIPROTOTYPE.hasClassName(el, "global-expander")) && (this._extractNameEmail(event,el) || this._extractLabel(event, el)) ) GIPROTOTYPE.stop(event);
}catch(e){
	if( GTDDEBUGMODE ) alert("contactfilter stopevent\n" + e.toString());
}
};
FilterEnvironment.prototype._processClick = function(event, el){
try{
	el = el || GIPROTOTYPE.element(event);
	var contact = this._extractNameEmail(event, el);
	if( contact ){
		GIPROTOTYPE.stop(event);
		this.createContactPopup(contact[0], contact[1], el);
	}else{
		var label = this._extractLabel(event, el);
		if( label ){
			GIPROTOTYPE.stop(event);
			this.createLabelPopup(label, el);
		}else{
			if( el.getAttribute("gtdSearch") ){
				GIPROTOTYPE.stop(event);
				this.createLabelPopup(null, el, el.getAttribute("gtdSearch"));
			}
		}
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("contactfilterpopuper mousedown\n" + e.toString());
}
};

FilterEnvironment.prototype._extractLabel = function(event, el){
try{
	var labelName = el.getAttribute("gtdLabelName");
	if( !labelName ){	// Try thread row item
		if( el.nodeName=="B" ){
			var i = 4;
			var elTree = el;
			while( i-->0 ){
				elTree = elTree.parentNode;
				if( elTree.className && elTree.className && (elTree.className=="YgSLI" && elTree.nodeName=="DIV") || (elTree.className=="lMVONe" && elTree.nodeName=="SPAN") || (elTree.className=="s75Nkf" && elTree.nodeName=="SPAN") ){
					labelName = GIPROTOTYPE.decodeEntities(el.innerHTML.replace(/<[^>]+>/g, ""));
					break;
				}
			}
		}
	}
	if( !labelName ){	// Try newer thread row item
		if( el.nodeName=="DIV" ){
			var i = 4;
			var elTree = el;
			while( i-->0 ){
				elTree = elTree.parentNode;
				if( elTree.className && elTree.className.indexOf("lMVONe")>-1 && elTree.nodeName=="DIV"  ){
					labelName = GIPROTOTYPE.decodeEntities(el.innerHTML.replace(/<[^>]+>/g, ""));
					break;
				}
			}
		}
	}
	if( !labelName ){	// Try newer thread row item
		if( el.nodeName=="DIV" && el.className=="av" ){
			labelName = GIPROTOTYPE.decodeEntities(GIPROTOTYPE.stripTags(el.innerHTML));
		}
	}
	if( !labelName ){
		if( (el.className=="MgLW8b" && el.nodeName=="SPAN") ){	// Conversation
			labelName = el.getAttribute("name");
		}
	}
	return labelName;
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterEnvironment extractLabel\n" + e.toString());
}
};
FilterEnvironment.prototype._extractNameEmail = function(event, el){
try{
	var name = "";
	var email = "";
	if( email = el.getAttribute("email") ){
	}else if( el.className=="HHshnc" && el.nodeName=="SPAN" ){	// contacts box
		name = GIPROTOTYPE.decodeEntities(el.innerHTML.replace(/<[^>]+>/g, ""));
	}else if( el.className=="Gqb6V" && el.nodeName=="TD" ){	// contacts box
		var els = el.getElementsByTagName("SPAN");
		for( var i = 0; i < els.length; i++ ){
			if( els[i].className=="HHshnc" ){
				name = GIPROTOTYPE.decodeEntities(els[i].innerHTML.replace(/<[^>]+>/g, ""));
			}
		}
	}else if( el.className.indexOf("QO5lqe")>-1 && el.nodeName=="DIV" && el.parentNode.nodeName=="TD" ){	// chat
		name = el.innerHTML;
	}else if( el.className=="text" && el.parentNode.className.indexOf("row")>-1 && el.previousSibling && el.previousSibling.className=="check" ){ // real contacts
		name = el.innerHTML;
		email = el.title;
	}else if( el.getAttribute("gtdSearch") && el.getAttribute("gtdType")=="Contact" && el.getAttribte("gtdName") ){
		name = el.getAttribute(gtdName);
		if( name.indexOf("@")>-1 ) email = name;
	}
	if( name || email ){
		return [name, email];
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterEnvironment extractName\n" + e.toString());
}
};

FilterEnvironment.prototype.destroy = function(){
	this._eventObservers.destroy();
	this._doc = null;
	this._gtdinboxPage = null;
		
	if( this._filterChild ){
		this._filterChild.destroy();
		this._filterChild = null;
	}
};

FilterEnvironment.prototype.createPopupArrow = function(el, labelName){
	// Create an arrow and return it
	// If el provided, 
	// If no labelname, try to extract it from el
};
