/* Copyright Andy Mitchell 2007. No warranties */

function FilterPopupUI4(gtdinboxPage){
try{
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = gtdinboxPage._labels;
	this._eventObservers = new GtdEventObservers(this);
	
	
	this.el = this._doc.createElement("DIV");
		this.el.className = "filter-popup";
		this.el.style.display = "none";
	this._popuper = new GtdPopuper(this._gtdinboxPage, this.el, this);
	this._popuper.addEventHandler( this, "popupOff", this.onPopupOff );	
	var doc = this._gtdinboxPage.gmailDOM.element("document");
	if( doc ) doc.body.appendChild( this.el );
	
	this.elTitle = this._doc.createElement("DIV");
		this.elTitle.className = "title";
	this.el.appendChild( this.elTitle );
	
	this.elTitleTxt = this._doc.createElement("DIV");
		this.elTitleTxt.className = "";
	this.elTitle.appendChild(this.elTitleTxt);
	
	var elClose = this._doc.createElement("IMG");
		elClose.src = "chrome://gtdinbox/content/cross.png";
		elClose.className = "close-button";
		elClose.style.position = "absolute";
		elClose.style.right = "0px";
		elClose.style.top = "0px";
		this._eventObservers.observe(elClose, "mousedown", this.clickClose, false);
	this.elTitle.appendChild(elClose);
	
	
	this._eventObservers.observe( this.el, "click", this.mouseDown, true);
	this._eventObservers.observe( this.el, "contextmenu", this.contextMenu, true);
	
	

	return this;
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterPopupUI4 construct\n" + e.toString());
}
};

FilterPopupUI4.prototype.refresh = function(name, type){
	// Update the title
	// Refine the view to show/hide the right TaskPane stuff for the type.
	// Setup the parent search and refresh the task pane. 
try{

	if( !this._taskPane2 ){
	
		this._taskPane1 = new TaskPaneUI(this._gtdinboxPage, true, true, true);
			GIPROTOTYPE.addClassName( this._taskPane1.groups["Reviews"].elContent, "reviews" );
		this._taskPane2 = new TaskPaneUI(this._gtdinboxPage, true, null, null, true);
		this.el.appendChild( this._taskPane1.el );
		this.el.appendChild( this._taskPane2.el );
		var elClear = this._doc.createElement("DIV");
			elClear.style.clear = "both";
		this.el.appendChild( elClear );
		
		GIPROTOTYPE.addClassName( this._taskPane1.el, "taskpane-statics" );
		GIPROTOTYPE.addClassName( this._taskPane2.el, "taskpane-accordions" );

		// Add Task Pane stuff:
		this._taskPane1.createGroup("Intro", "Static", null, "Reviews");
			this._taskPane1.createGroupItem("Intro", "Compose", null, null, "");
			this._taskPane1.createGroupItem("Intro", "ViewAll", null, null, "");
			this._taskPane1.createGroupItem("Intro", "ViewPersonal", null, null, "");
			this._taskPane1.createGroupItem("Intro", "RenameLabel", null, null, "");
			this._taskPane1.createGroupItem("Intro", "RenameOld", null, null, "");
			//this._taskPane1.createGroupItem("Intro", "DeleteLabel", null, null, "");
		this._taskPane2.createGroup("History", "Accordion");
			this._taskPane2.createGroupItem("History", "Recent", "ThreadList", null, "-chat after:<?=DaysAgo.31>", null, 100);
			this._taskPane2.createGroupItem("History", "Unread", "ThreadList", null, "is:unread", null, 100);
			this._taskPane2.createGroupItem("History", "Files", "ThreadList", null, "has:attachment after:<?=MonthsAgo.3>", null, 100);
		var groupSearch = this._taskPane1.createGroup("Search", "Static");
			var elSearch = this._doc.createElement("DIV");
				elSearch.className = "search";
			var elSearchInput = this._doc.createElement("INPUT");
				elSearchInput.setAttribute("type", "text");
			elSearch.appendChild( elSearchInput );
			var elSearchCmd = this._doc.createElement("BUTTON");
				elSearchCmd.innerHTML = this._gtdinboxPage.stringBundle.getString("FilterPopup.SearchButton");	
			elSearch.appendChild( elSearchCmd );
			groupSearch.elContent.appendChild( elSearch );
	}
	
	// Update the data:
	this._status = this._gtdinboxPage.getStatusData();
	this._old = this._gtdinboxPage.settings.labels.types.Old.prefix;
	if( name instanceof Array ){	// contact, [name,email]
		this._name = name[0] || name[1];
		this._email = name[1];
	}else{
		this._name = name;
	}
	this._type = type;
	
	// Update the title:
	if( type=="Contact" ) this._closeContacts = new CloseContacts( this._gtdinboxPage );
	
	this.elTitleTxt.innerHTML = "";
	if( this._type=="Search" ){
		this.elTitleTxt.innerHTML = name;
	}else{
		this.elTitleTxt.appendChild( this._doc.createTextNode((this._name || this._email || "")) );
		if( this._type=="Contact" ){	// Load the closeness
			this._closeContacts.processContacts(null, [this._email || this._name], GIPROTOTYPE.bind(this, function(contacts, contactsHash){
					var elCloseness = this._doc.createElement("IMG");
						elCloseness.className = "closeness";
					if( contacts.length > 0 ){
						elCloseness.src = contacts[0].closenessImgSrc;
						elCloseness.title = contacts[0].closenessTooltip;
					}else{
						elCloseness.src = this._closeContacts.getZeroClosenessImg();
					}
					this.elTitleTxt.insertBefore( elCloseness, this.elTitleTxt.firstChild );
				}));
			
		}
	}
	
		
	
	// Now refine the view based on type
	this._taskPane1.groups["Intro"].items["ViewAll"].section.elContent.setAttribute("_gtdSearch", " ");
	this._taskPane1.groups["Intro"].items["ViewPersonal"].section.elContent.setAttribute("_gtdSearch", GIPROTOTYPE.restrictSearchToUser(this._gtdinboxPage._environment.emails) );
	this._taskPane1.groups["Intro"].items["RenameLabel"].section.elContent.setAttribute("gtdSearch", "special.renameLabel:" + name);
	this._taskPane1.groups["Intro"].items["RenameOld"].section.elContent.setAttribute("gtdSearch", "special.renameOld:" + name);
		if( name.indexOf( this._old )==0 ){	// Old label
			this._taskPane1.groups["Intro"].items["RenameOld"].section.elContent.innerHTML = this._gtdinboxPage.stringBundle.getString("TaskPane.Intro.RenameOld1");
		}else{
			this._taskPane1.groups["Intro"].items["RenameOld"].section.elContent.innerHTML = this._gtdinboxPage.stringBundle.getString("TaskPane.Intro.RenameOld");
		}
	//this._taskPane1.groups["Intro"].items["DeleteLabel"].section.elContent.setAttribute("gtdSearch", "special.deleteLabel:" + name);
	
	this._taskPane2.hideGroup("TasksToDo", false);
	this._taskPane2.hideGroup("TasksWaitingOn", false);
	this._taskPane2.hideGroupItem("History", "Unread", false);
	this._taskPane1.hideGroupItem("Intro", "Compose", true);
	this._taskPane1.hideGroupItem("Intro", "ViewPersonal", false);
	this._taskPane1.hideGroupItem("Intro", "RenameLabel", false);
	this._taskPane1.hideGroupItem("Intro", "RenameOld", false);
	//this._taskPane1.hideGroupItem("Intro", "DeleteLabel", false);
	this._taskPane2.hideGroupItem("TasksToDo", "Project", false);
	this._taskPane2.hideGroupItem("TasksWaitingOn", "Project", false);
	this._taskPane2.hideGroupItem("TasksToDo", "Contact", false);
	this._taskPane2.hideGroupItem("TasksWaitingOn", "Contact", false);
	var parentSearch = "";
	switch( this._type ){
		case "Statuses":
			parentSearch = "(" + GIPROTOTYPE.searchableLabel(name) + " -" + GIPROTOTYPE.searchableLabel(status.Finished) + ")";	// The Status less Finished (unless it is Finished)
			this._taskPane2.hideGroup("TasksToDo", true);
			this._taskPane2.hideGroup("TasksWaitingOn", true);
			break;
		case "Projects":
			this._taskPane2.hideGroupItem("TasksToDo", "Project", true);
			this._taskPane2.hideGroupItem("TasksWaitingOn", "Project", true);
			parentSearch = GIPROTOTYPE.searchableLabel(name);
			break;
		case "Contexts":
			parentSearch = GIPROTOTYPE.searchableLabel(name);
			break;
		case "References":
			parentSearch = GIPROTOTYPE.searchableLabel(name);
			break;
		case "Search":
			parentSearch = name;
			break;
		case "Misc":
			parentSearch = GIPROTOTYPE.searchableLabel(name);
			break;
		case "Old":
			parentSearch = GIPROTOTYPE.searchableLabel(name);
			break;
		case "Contact":
			parentSearch = "(";
			if( this._email ) parentSearch += "from:" + this._email + " OR to:" + this._email;
			if( this._name ) parentSearch += (parentSearch? " OR " : "") + "from:\"" + this._name + "\" OR to:\"" + this._name + "\"";
			parentSearch = "(" + parentSearch + ")";
			if( this._email ) this._taskPane1.hideGroupItem("Intro", "Compose", false);
			this._taskPane1.hideGroupItem("Intro", "ViewPersonal", true);
			this._taskPane1.hideGroupItem("Intro", "RenameLabel", true);
			this._taskPane1.hideGroupItem("Intro", "RenameOld", true);
			//this._taskPane1.hideGroupItem("Intro", "DeleteLabel", true);
			this._taskPane1.groups["Intro"].items["Compose"].section.elContent.setAttribute("gtdSearch", "special.compose:" + this._email);
			this._taskPane1.groups["Intro"].items["Compose"].section.elContent.innerHTML = this._gtdinboxPage.stringBundle.getStringSafe("TaskPane.Intro.Compose","Compose") + " " + this._email;
			this._taskPane2.hideGroupItem("TasksToDo", "Contact", true);
			this._taskPane2.hideGroupItem("TasksWaitingOn", "Contact", true);
			break;
	}
	
	this._parentSearch = parentSearch;
	
	// Cause it to reload:
	this._taskPane1.refresh(parentSearch);
	this._taskPane2.refresh(parentSearch);
		
	
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterPopupUI4 refresh\n" + e.toString());
}
};


















































FilterPopupUI4.prototype.contextMenu = function(event){
	var el = GIPROTOTYPE.element(event);
	if( el.getAttribute("gtdName") ){
		GIPROTOTYPE.stop(event);
		this.clickExtend(el);
	}
};
FilterPopupUI4.prototype.mouseDown = function(event){
	
	try{
		var el = GIPROTOTYPE.element(event);
		if( event.button==2 ) return;
		if( event.shiftKey ){	// async
			this.popupOff();
			return;
		}
		
		
		// Detect the type (search button, extend button, regular filter)
		if( el.nodeName=="BUTTON" ){	// search
			el = el.parentNode.getElementsByTagName("INPUT")[0];
			this._gtdinboxPage._searchBoxUI.search( this._parentSearch + " " + el.value );
			GIPROTOTYPE.stop(event);
			this.popupOff();
		/*
		}else if( el.nodeName=="IMG" && el.className=="show-threads" ){
			GIPROTOTYPE.stop(event);
			var elLink = el.parentNode;
			while( elLink.parentNode && elLink.className.indexOf("link")==-1 ){
				elLink = elLink.parentNode;
			}
			if( elLink.parentNode ){
				var elPreview = elLink.nextSibling;
				while( elPreview.nextSibling && elPreview.className.indexOf("show-threads-preview-box")==-1 ){
					elPreview = elPreview.nextSibling;
				}
				if( elPreview.className.indexOf("show-threads-preview-box")>-1 ){
					if( elPreview.innerHTML=="" ){	// Load it
						this._searcher.search( elLink.getAttribute("gtdSearch"), GIPROTOTYPE.bind(this, function(threadList){
							if( threadList._threads.length > 0 ){
								var threadListCustomUI = new ThreadListCustomUI(this._gtdinboxPage );
								threadListCustomUI.load( threadList, null, {excludeNames:true, excludeDate:true, excludeLabels:true, tooltipNames:true, tooltipDate:true} );
								this._threadListCustomUIs.push( threadListCustomUI );
								elPreview.appendChild(threadListCustomUI.el);
							}
						}));
					}
					if( elPreview.style.display=="none" ){
						elPreview.style.display = "";
					}else{
						elPreview.style.display = "none";
					}
				}
			}
		*/
		}else if( el.getAttribute("gtdSearch") ){
			var search = el.getAttribute("gtdSearch");
			if( search.indexOf("special.compose:")==0 ){
				this._gtdinboxPage._composeUI.clickComposeTo( search.replace("special.compose:", "") );
			}else if( search.indexOf("special.")==0 ){
				var action = search.substr(0, search.indexOf(":"));
				var labelName = search.substr(search.indexOf(":") + 1);
				switch( action ){
					case "special.renameLabel":
						var newLabel = prompt(this._gtdinboxPage.stringBundle.getString("FilterPopup.PromptRename"), labelName);
						if( newLabel && newLabel!=labelName ){
							this._gtdinboxPage.gmailDOM.renameLabel( [labelName, newLabel], null, GIPROTOTYPE.bind(this, function(){
									this.refresh( newLabel, this._type );
									this._gtdinboxPage.gmailDOM.refreshView()
								}));
						}
						break;
					case "special.renameOld":
						var newLabel = "";
						if( labelName.indexOf(this._old)==0 ){	// It's old, rename it not old
							newLabel = labelName.replace(this._old, "");
						}else{
							newLabel = this._old + labelName;
						}
						this._gtdinboxPage.gmailDOM.renameLabel( [labelName, newLabel], null, GIPROTOTYPE.bind(this, function(){
								this.refresh( newLabel, this._type );
								this._gtdinboxPage.gmailDOM.refreshView()
							}));
						break;				
				}
			}else{
				this._gtdinboxPage._searchBoxUI.search( (search||"") );
			}
			GIPROTOTYPE.stop(event);
			this.popupOff();
		}else{
			while( el.parentNode ){
				if( el.className.indexOf("thread-list-custom")>-1 ){	// Clicked thread list
					this.popupOff();
				}
				el = el.parentNode;
			}
		}
	}catch(e){
		if( GTDDEBUGMODE ) alert("filterpopup mouseDown\n" + e.toString());
	}
};




FilterPopupUI4.prototype.onPopupOff = function(){
};
FilterPopupUI4.prototype.clickClose = function(){
	this.popupOff();
}
FilterPopupUI4.prototype.destroy = function(){
try{
	if( !this.el ) return;	// already destroyed
	
	
	if( this._popuper ){
		this._popuper.resetDeadZones(); // ensure doesn't fire and close me again
		this._popuper.resetEventHandlers();	// ensure doesn't fire and close me again
	}
	
	if( this.popupOff ) this.popupOff();
	if( this._popuper ) this._popuper.destroy();
	this._eventObservers.destroy();
	
	if( this._taskPane1 ) this._taskPane1.destroy();
	if( this._taskPane2 ) this._taskPane2.destroy();
	
	if( this._closeContacts ) this._closeContacts.destroy();
	
	
	this._gtdinboxPage = null;
	this._doc = null;
	
	if( this.el && this.el.parentNode ) this.el.parentNode.removeChild(this.el);
	this.el = null;
}catch(e){
	if( GTDDEBUGMODE ) alert("FilterPopupUI4 destroy\n" + e.toString());
}
};










