/* Copyright Andy Mitchell 2007, 2008. No warranties */

function LabelsBoxCount(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
		
	this._multiToOne = new MultiToOne(gtdinboxPage, 3000);
		this._multiToOne._timeLast = 0;
	
	this._gtdinboxPage._cacheStatuses.addEventHandler(this, "refreshed-labels", this.refreshLabelsUI);
		
	// Handle manual thread changes:
	/*
	var fRefresh = function(obj, labelname){
			setTimeout( GIPROTOTYPE.bind(this, function(){
				this.refresh(false, labelname)
			}), 300 );
		};
	
	this._gtdinboxPage._threadList.addEventHandler(this, "addThreadLabel", fRefresh );
	this._gtdinboxPage._threadList.addEventHandler(this, "removeThreadLabel", fRefresh );
	*/
	
};



LabelsBoxCount.prototype.refresh = function(full, labelname, forceRun){
try{
	
	
	// Try to queue it:
	var d = (new Date).valueOf();
	if( this._runOnce && !forceRun ){	// Activate rate limiting. If > 25 seconds since last run, run it immediately. Otherwise set up callback.
		if( (d-this._multiToOne._timeLast)>3000 ){	// More than 25 seconds. Run instantly.
			
		}else{
			this._multiToOne.process("refresh", GIPROTOTYPE.bind(this, function(){	// Pause for 25 seconds.
				this.refresh(full, labelname, true)}));
			return;
		}
	}
	this._multiToOne._timeLast = d;
	this._runOnce = true;
	
	

	// Find each label
	// If changed since last processed, update
		
	var status = this._gtdinboxPage.getStatusData();
		
		
	// Process each label:
	var labelsToQuery = [];
	var typeBuckets = this._gtdinboxPage._labels.typeBuckets;
	if( typeBuckets.Statuses ){
		for( l in typeBuckets.Statuses.labels ){
			var labelObj = typeBuckets.Statuses.labels[l];
			if( labelObj.labelName!=status.Finished ){				
				if( !this._hasSquareBrackets(labelObj.elName) ){
					labelsToQuery.push(labelObj.labelName);
				}
			}
		}
	}

	
	this.refreshLabelsUI();
	if( labelsToQuery==0 ){	// Repair any other round brackets
		//this.refreshLabelsUI();
	}else{	// Update the cache
		//this.refreshLabelsUI();
		this._gtdinboxPage._cacheStatuses.refreshLabels(labelsToQuery);
	}
	

}catch(e){
	if( GTDDEBUGMODE ) alert("LabelsBoxCount refresh\n" + e.toString());
}
};



LabelsBoxCount.prototype.refreshLabelsUI = function(){
	// Called directly, or as a broadcast from CacheStatuses
try{

	var wasObserving = this._gtdinboxPage._labels.observeChanges();
	

	if( !this._gtdinboxPage._cacheStatuses.threadList ) return;

	if( wasObserving ) this._gtdinboxPage._labels.observeChanges(false);

	var status = this._gtdinboxPage.getStatusData();
	
	var cacheStatuses = this._gtdinboxPage._cacheStatuses;
	var typeBuckets = this._gtdinboxPage._labels.typeBuckets;
	
	for( t in typeBuckets ){
		//if( this._gtdinboxPage.settings.ui.showCounts[t] ){
			for( l in typeBuckets[t].labels ){
				var labelObj = typeBuckets[t].labels[l];
				if( labelObj.labelName!=status.Finished ){
					//if( !this._hasSquareBrackets(labelObj.elName) ){
						var unreadCount = this._extractLabelCount( labelObj.elName );
						labelObj.elName.setAttribute("gtd-labelsboxcount-unread", unreadCount);
						cacheStatuses.updateUnreadFromLabelBox( labelObj.labelName, unreadCount );

												
						if( cacheStatuses.labelsWithStatus[ labelObj.labelName ] ){
							var labelWithStatus = cacheStatuses.labelsWithStatus[ labelObj.labelName ];
							if( labelObj.type=="Statuses" ){
								if( labelWithStatus.threads.length > 0 ){
									labelObj.elName.innerHTML = labelObj.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1") + " [" + labelWithStatus.threads.length + "]";
									labelObj.elName.style.fontWeight = "bold";
								}else{
									labelObj.elName.innerHTML = labelObj.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1");
									labelObj.elName.style.fontWeight = "normal";
								}
							}else{
								var totalCount = labelWithStatus.threads.length + labelWithStatus.unreadCount;
								if( totalCount > 0 ){
									labelObj.elName.innerHTML = labelObj.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1") + " [" + totalCount + "]";
									labelObj.elName.style.fontWeight = "bold";
								}else{
									labelObj.elName.innerHTML = labelObj.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1");
									labelObj.elName.style.fontWeight = "normal";
								}
							}
							labelObj.elName.title = labelObj.labelName + " (" + labelWithStatus.unreadCount + " " + this._gtdinboxPage.stringBundle.getString("LabelsBoxCount.Unread") + ", " + labelWithStatus.threads.length + " " + this._gtdinboxPage.stringBundle.getString("Labels.Types.Statuses") + ")";
						}
					//}
				}
			}
		//}
	}
	
	if( wasObserving ) this._gtdinboxPage._labels.observeChanges(true);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("LabelsBoxCount refresh\n" + e.toString());
}
};



/*
LabelsBoxCount.prototype.refresh = function(full, labelname, forceRun){
try{

	// Try to queue it:
	var d = (new Date).valueOf();
	if( this._runOnce && !forceRun ){	// Activate rate limiting. If > 25 seconds since last run, run it immediately. Otherwise set up callback.
		if( (d-this._multiToOne._timeLast)>3000 ){	// More than 25 seconds. Run instantly.
			
		}else{
			this._multiToOne.process("refresh", GIPROTOTYPE.bind(this, function(){	// Pause for 25 seconds.
				this.refresh(full, labelname, true)}));
			return;
		}
	}
	this._multiToOne._timeLast = d;
	this._runOnce = true;
	

	// Find each label
	// If changed since last processed, update
		
	var status = this._gtdinboxPage.getStatusData();
		
	var found = false;
	for( t in this._gtdinboxPage.settings.ui.showCounts ) if( this._gtdinboxPage.settings.ui.showCounts[t] ) found = true;
	if( !found ) return; // Make sure there is something to do.

	this._gtdinboxPage._perfLogger.countCall("LabelsBoxCount.refresh");
	
	this._gtdinboxPage._perfLogger.countCall("LabelsBoxCount.refresh.inprogress");
	this._gtdinboxPage._perfLogger.logg("LabelsBoxCount.refresh", "start", true);

	// Do not allow full refreshes often

	// Lazy load:
	if( !this._searcher ) this._searcher = new Searcher(this._gtdinboxPage)
	
	
	// Try to clear out existing items
	//if( full ) this._labelHash = {};	// force clear out
	//if( labelname && this._labelHash[labelname] ) this._labelHash = {}; // has to full clear, as projects/contexts might use the status label //delete this._labelHash[labelname] // clear out just a label
	
		
	// Process each label:
	var labels = {};
	var labelsToQuery = [];
	var changedCount = false;	// Used to see if a count has changed (e.g. a mark read causing a non full/labelname update)
	var typeBuckets = this._gtdinboxPage._labels.typeBuckets;
	for( t in typeBuckets ){
		if( this._gtdinboxPage.settings.ui.showCounts[t] ){
			for( l in typeBuckets[t].labels ){
				var labelObj = typeBuckets[t].labels[l];
				if( labelObj.labelName!=status.Finished ){
					labels[labelObj.labelName] = {'data':labelObj, 'count':0};
					
					if( this._extractLabelCount( labelObj.elName, true )!=this._labelCounts[labelObj.labelName] ){
						labelsToQuery.push(labelObj.labelName);
						changedCount = true;
					}
				}
			}
		}
	}

	// Form the query. All active, unfinished, labels we are allowed to process.
	var q = this._gtdinboxPage._labels.getLabelsQuery(null, null, null, status.Finished, labelsToQuery);

	
	this._gtdinboxPage._perfLogger.logg("LabelsBoxCount.refresh", "check labels box");
	
	
	if( labelsToQuery.length==0 || (!changedCount && !full && !labelname) ){
		return;	// No point proceeding. Nothing changed.
	}
	
	
	this._gtdinboxPage._perfLogger.countCall("LabelsBoxCount.refresh.fullCallback");
	

	// Using the full query, load all threads
	
	this._searcher.search(q, GIPROTOTYPE.bind(this, function(threadList){
		try{
			for( var i = 0; i < threadList._threads.length; i++ ){
				var thread = threadList._threads[i];
				for( var j = 0; j < thread.labels.length; j++ ){
					if( labels[thread.labels[j]] ){
						labels[thread.labels[j]].count++;
					}
				}
			}
			
			
			
			// Now render the labels
			for( l in labels ){
				var label = labels[l];
				if( !/.+?\s\[(\d+)\]$/.test( label.data.elName.innerHTML ) ){	// Not currently []
					if( label.data.type=="Statuses" ){
						if( label.count > 0 ){
							label.data.elName.innerHTML = label.data.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1") + " [" + label.count + "]";
							label.data.elName.style.fontWeight = "bold";
						}else{
							label.data.elName.innerHTML = label.data.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1");
							label.data.elName.style.fontWeight = "normal";
						}
						label.data.elName.title = label.data.elName.innerHTML;
						this._labelCounts[label.data.labelName] = label.count;
					}else{
						var unread = this._extractLabelCount(label.data.elName);
						var totalCount = label.count + unread;
					
						if( totalCount > 0 ){
							label.data.elName.innerHTML = label.data.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1") + " [" + totalCount + "]";
							label.data.elName.style.fontWeight = "bold";
						}else{
							label.data.elName.innerHTML = label.data.elName.innerHTML.replace(/(.+?)(\s(\(|\[)\d+(\)|\]))?$/, "$1");
							label.data.elName.style.fontWeight = "normal";
						}
						label.data.elName.title = l + " (" + unread + " unread, " + label.count + " " + this._gtdinboxPage.stringBundle.getStringSafe("Labels.Types." + label.data.type, label.data.type) + ")";
						label.data.elName.setAttribute("gtd-labelsboxcount-unread", unread);
						this._labelCounts[label.data.labelName] = totalCount;
					}
				}
			}
			
			this._gtdinboxPage._perfLogger.logg("LabelsBoxCount.refresh", "end of callback");
				
		}catch(e){
			if( GTDDEBUGMODE ) alert("LabelsBoxCount refresh callback\n" + e.toString());
		}
	}));
	

}catch(e){
	if( GTDDEBUGMODE ) alert("LabelsBoxCount refresh\n" + e.toString());
}
};
*/


LabelsBoxCount.prototype._hasSquareBrackets = function(elName){
	return /.+?\s\[(\d+)\]$/.test( elName.innerHTML );
};

LabelsBoxCount.prototype._extractLabelCount = function(elName, forceRead){
	var html = elName.innerHTML;
	if( !forceRead && this._hasSquareBrackets(elName) ){	// changed by us
		return parseInt( elName.getAttribute("gtd-labelsboxcount-unread") );
	}else{
		var m = html.match( /.+?\s\((\d+)\)$/ );
		if( m && m[1] ) return parseInt(m[1]);
		var m = html.match( /.+?\s\[(\d+)\]$/ );
		if( m && m[1] ) return parseInt(m[1]);
		return 0;
	}
};