/* Copyright Andy Mitchell 2007, 2008. No warranties */

function MoreActionsMenu(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._eventObservers = new GtdEventObservers(this);
	this._eventObserversList = new GtdEventObservers(this);
	this._eventHandlers = new GtdEventHandlers_Mutator(this);
	this._multiToOne = new MultiToOne(gtdinboxPage, 100);	
	this._queue = new GtdQueue(gtdinboxPage, this);
	this._customEntries = [];
	this._els = {};
	
	this._eventObservers.observe(this._doc, "keydown", function(event){
			if( event.keyCode==190) setTimeout(GIPROTOTYPE.bind(this, this.refresh), 1000);
		}, false);
	
}


MoreActionsMenu.prototype.viewChange = function(gmail){
	/*
		Clear out existing event handlers and links to elements; and hook in new menu buttons and attach click handlers.
	*/
	
try{
	

	this._eventObservers.reset();
	for( e in this._els ){
		if( this._els[e] ) this._els[e].setAttribute("gtdName", "");
		delete this._els[e];
	}
	
	if( !(this._gtdinboxPage.view("view")=="cv" || this._gtdinboxPage.view("view")=="tl") ) return;
	
	this._customEntries.length = 0; // Clear out. Means MoreActionsMenu viewChange must go first.
	
	this._els["move-to"] = this._gtdinboxPage.gmailDOM.element("menu-move-to");
		this._els["move-to"].setAttribute("gtdName", "move-to");
	this._els["move-to-bottom"] = this._gtdinboxPage.gmailDOM.element("menu-move-to-bottom");
		this._els["move-to-bottom"].setAttribute("gtdName", "move-to-bottom");
		
	this._els["labels"] = this._gtdinboxPage.gmailDOM.element("menu-labels");
		this._els["labels"].setAttribute("gtdName", "labels");
	this._els["labels-bottom"] = this._gtdinboxPage.gmailDOM.element("menu-labels-bottom");
		this._els["labels-bottom"].setAttribute("gtdName", "labels-bottom");
		
	this._els["more-actions"] = this._gtdinboxPage.gmailDOM.element("menu-more-actions");
		this._els["more-actions"].setAttribute("gtdName", "more-actions");
	this._els["more-actions-bottom"] = this._gtdinboxPage.gmailDOM.element("menu-more-actions-bottom");
		this._els["more-actions-bottom"].setAttribute("gtdName", "more-actions-bottom");
	
	for( e in this._els ){
		this._eventObservers.observe( this._els[e], "click", this._menuClick, false );
	}

}catch(e){ if( GTDDEBUGMODE ) alert("MoreActionsMenu viewChange\n" + e.toString()) }
};

MoreActionsMenu.prototype._menuClick = function(event){
	/*
		Switching on the name,
			Grab the open dropdown
			If labels list, order it.
			(Opportune time to add click handler to the dropdown)
	*/
	
try{

	var el = GIPROTOTYPE.element(event);
	while( el.parentNode && !el.getAttribute("gtdName") ) el = el.parentNode;
	if( !el.parentNode ) return;
	var name = el.getAttribute("gtdName");
	
	this._eventObserversList.reset();
	var elDropdownList = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-" + name);
	
	if( name.indexOf( "move-to" )>-1 ){
		this._refreshLabelList( elDropdownList );
	}else if( name.indexOf( "labels" )>-1 ){
		this._refreshLabelList( elDropdownList, "goog-tristatemenuitem", "goog-tristatemenuitem-content" );
	}
	
	if( name.indexOf("move-to")>-1 || name.indexOf("labels")>-1 ){
		// Set up event observers for lists
		this._eventObserversList.observe( elDropdownList, "click", this._listClick, false );			
	}
	
	


}catch(e){ if( GTDDEBUGMODE ) alert("MoreActionsMenu _menuClick\n" + e.toString()) }
};

MoreActionsMenu.prototype._listClick = function(event){
	/*
		Detect what, if any, label was clicked; and broadcast it.
	*/
try{

	
	
		
	var el = GIPROTOTYPE.element(event);
	while( el.parentNode && el.getAttribute("role")!="menuitem" ) el = el.parentNode;
	if( !el.parentNode ) return;
	
	
	this._eventObserversList.reset();
	
	var label = GIPROTOTYPE.stripTags(el.innerHTML);
	var safelabel = label.replace(/\"/g, "\\\"");
	
		
	var act = 13;
	if( el.getAttribute("aria-checked")=="true" ){	// Update is instant - already inverted.
		act = 12;
	}
		
	
	this._eventHandlers.broadcast("actionlist-manual-click", {'label':label, 'act':act, 'safelabel':safelabel});
	
}catch(e){ if( GTDDEBUGMODE ) alert("MoreActionsMenu _menuClick\n" + e.toString()) }
};


MoreActionsMenu.prototype._refreshLabelList = function(elDropdownList, itemClass, itemContentClass){
	/*
		Re-order the MoveTo/Labels lists to group by Type (Status/Context). 
	*/

try{

	return;	// No longer needed

	if( !itemClass ) itemClass = "goog-menuitem";
	if( !itemContentClass ) itemContentClass = "goog-menuitem-content";
	
	
	
	var fCreateEntry = GIPROTOTYPE.bind(this, function(elChild, id, name, tooltip, customClassName){
			var elLi = this._doc.createElement("DIV");
				elLi.className = itemClass + " " + customClassName;
				elLi.title = tooltip;
				elLi.setAttribute("gtd-more-actions-id", id);
			
			var elLiContent = this._doc.createElement("DIV");
				elLiContent.className = itemContentClass;
				elLiContent.innerHTML = name;
			
			elLi.appendChild( elLiContent );
			elDropdownList.insertBefore( elLi, elChild );
	
			return elLi;
		});
	
		
	var typeSettings = this._gtdinboxPage.settings.labels.types;
	var statusLabelsHash = {};	// [labelname] = el
	var labelsHash = {};	//[type] = {elTitle, elLabels:[]}
	for( t in this._gtdinboxPage._labels.typeBuckets ){
		labelsHash[t] = {'elTitle':this._doc.createElement("DIV"), 'elLabels':[]};
			labelsHash[t].elTitle.innerHTML = this._gtdinboxPage.stringBundle.getStringSafe("Labels.Types." + t, t);
			labelsHash[t].elTitle.className = "gtd-more-actions-title";
	}
	
	var elFirstItem = null;
	var childList = [];
	for( var i = 0; i < elDropdownList.childNodes.length; i++ ) childList[i] = elDropdownList.childNodes[i];	// CLone to stop it changing order on updates
	for( var i = 0; i < childList.length; i++ ){
		var elChild = childList[i];
		
		
		var innerHTML = GIPROTOTYPE.stripTags(elChild.innerHTML);
	
		if( !elFirstItem ){	// Found first entry
			elFirstItem = elChild;
			
			if( labelsHash.Statuses ) elFirstItem.parentNode.insertBefore( labelsHash.Statuses.elTitle, elFirstItem );
			for( t in labelsHash ){
				if( t!="Statuses" && t!="Misc" ) elFirstItem.parentNode.insertBefore( labelsHash[t].elTitle, elFirstItem );
			}
			if( labelsHash.Misc ) elFirstItem.parentNode.insertBefore( labelsHash.Misc.elTitle, elFirstItem );
		}
					
		var type = "Misc";
		for( t in typeSettings ){
			if( typeSettings[t].prefix && innerHTML.indexOf( typeSettings[t].prefix )==0 ){
				type = t;
				break;
			}
		}
		if( type=="Statuses" ){
			statusLabelsHash[innerHTML] = elChild;
		}
		if( labelsHash[type].elLabels.length > 0 ){	// Has children
			var lastNode = labelsHash[type].elLabels[ labelsHash[type].elLabels.length - 1 ];
			lastNode.parentNode.insertBefore( elChild, lastNode.nextSibling );
		}else{	// First one
			labelsHash[type].elTitle.parentNode.insertBefore( elChild, labelsHash[type].elTitle.nextSibling );
		}
		labelsHash[type].elLabels.push(elChild);
	}
	
	// Re-arrange Statuses
	var statusArray = this._gtdinboxPage._labels.getLabelsArray("Statuses", true).reverse();
	for( var i = 0; i < statusArray.length; i++ ){
		if( statusLabelsHash[statusArray[i]] ) labelsHash.Statuses.elTitle.parentNode.insertBefore( statusLabelsHash[statusArray[i]], labelsHash.Statuses.elTitle.nextSibling );
	}
}catch(e){ if( GTDDEBUGMODE ) alert("MoreActionsMenu refreshLabelList\n" + e.toString()) }	
};

MoreActionsMenu.prototype.customEntries = function(v){
	if( typeof v=="undefined" ) return this._customEntries;
	
	if( a instanceof Array ) this._customEntries = a;
};
MoreActionsMenu.prototype.addCustomEntry = function(id, name, tooltip, callback){
	this._customEntries.push( {'id':id, 'name':name, 'tooltip':tooltip, 'callback':callback} );
};
MoreActionsMenu.prototype.removeCustomEntry = function(id){
	for( var i = 0; i < this._customEntries.length; i++ ){
		if( this._customEntries[i].id==id ){
			this._customEntries.splice(i,1);
			return;
		}
	}
};



MoreActionsMenu.prototype._testLabelListExists = function(name, fCallback, force){
	/*
		Test if can find appropriate label-list element via xpath.
		If not, click on/off the label box to make Gmail instantiate a label-list element.
		The 'force' variable is used because Gmail ignores subsequent label-list-item clicks if the label-list is not clicked first.
	*/
	
try{

	var elList = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-" + name);
		
	var elMenu = this._gtdinboxPage.gmailDOM.element("menu-" + name);
	
	if( elList ){
		if( force ){
			GIPROTOTYPE.doMouseEvent(this._doc, elMenu, "mousedown");
			GIPROTOTYPE.doMouseEvent(this._doc, elMenu, "mousedown");
		}
		if( fCallback ) fCallback();
	}else{
		GIPROTOTYPE.doMouseEvent(this._doc, elMenu, "mousedown");
		GIPROTOTYPE.doMouseEvent(this._doc, elMenu, "mousedown");
		if( fCallback ) setTimeout( fCallback, 750 );
	}

}catch(e){ if( GTDDEBUGMODE ) alert("MoreActionsMenu _testLabelListExists\n" + e.toString()) }
};



MoreActionsMenu.prototype.addLabel = function(labelname, fCallback, _qItem, _tested){
try{
	/*
		Queue it up (we have to, as it's a single threaded process).
		Test to make sure the list of labels has been loaded.
		Scan the list of labels,
			If it's checked, remove from queue and callback.
			Otherwise, click it (mousedown+mouseup), and rescan list every 200ms (up to 2 seconds) until it's recorded as checked. 
	*/
	
	
	
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){ this.addLabel(labelname, fCallback, qItem) })
		return;
	}
	
	if( !_tested ){	// Test label list
		this._testLabelListExists("labels", GIPROTOTYPE.bind(this, function(){this.addLabel(labelname, fCallback, _qItem, true)}), true);
		return;
	}
		
	// Scan the list of labels
	var elList = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-labels");
	for( var i = 0; i < elList.childNodes.length; i++ ){
		var elLi = elList.childNodes[i];
		if( GIPROTOTYPE.stripTags(elLi.innerHTML)==labelname ){	// Match
			if( elLi.getAttribute("aria-checked")=="true" ){	// Already on
				if( fCallback ) fCallback();
				_qItem.release();
			}else{	// Turn it on; then test when it's activated.
				GIPROTOTYPE.gmailButtonClick(this._doc, elLi);
				var count = 0;
				this._addLabelInterval = setInterval( GIPROTOTYPE.bind(this, function(){
						if( elLi.getAttribute("aria-checked")=="true" || ++count>5 ){
							clearInterval( this._addLabelInterval );
							setTimeout( GIPROTOTYPE.bind(this, function(){
								if( fCallback ) fCallback();
								_qItem.release();
							}), 500 );
						}
					}), 200);
			}
			return;
		}
	}

}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu addLabel\n" + e.toString())
}
};

MoreActionsMenu.prototype.removeLabel = function(labelname, fCallback, _qItem, _tested){
try{
	/*
		Queue it up (we have to, as it's a single threaded process).
		Test to make sure the list of labels has been loaded.
		Scan the list of labels,
			If it's unchecked, remove from queue and callback.
			Otherwise, click it (mousedown+mouseup), and rescan list every 200ms (up to 2 seconds) until it's recorded as checked. 
	*/
	
	
	
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){ this.removeLabel(labelname, fCallback, qItem) })
		return;
	}
	
	if( !_tested ){	// Test label list
		this._testLabelListExists("labels", GIPROTOTYPE.bind(this, function(){this.removeLabel(labelname, fCallback, _qItem, true)}), true);
		return;
	}

	

	// Scan the list of labels
	var elList = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-labels");
	for( var i = 0; i < elList.childNodes.length; i++ ){
		var elLi = elList.childNodes[i];
		if( GIPROTOTYPE.stripTags(elLi.innerHTML)==labelname ){	// Match
			if( elLi.getAttribute("aria-checked")!="true" ){	// Already off
				if( fCallback ) fCallback();
				_qItem.release();
			}else{	// Turn it off; then test when it's activated.
				GIPROTOTYPE.gmailButtonClick(this._doc, elLi);
				var count = 0;
				this._removeLabelInterval = setInterval( GIPROTOTYPE.bind(this, function(){
						if( elLi.getAttribute("aria-checked")!="true" || ++count>5 ){
							clearInterval( this._removeLabelInterval );
							setTimeout( GIPROTOTYPE.bind(this, function(){
								if( fCallback ) fCallback();
								_qItem.release();
							}), 500 );
						}
					}), 200);
			}
			return;
		}
	}
	
	
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu removeLabel\n" + e.toString()) 
}
};




MoreActionsMenu.prototype.createLabel = function(fCallback, _qItem, _tested){
try{
	
	/*
		Click the 'Create Label' option
	*/
	
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.createLabel(fCallback, qItem)} );
		return;
	}
	
	
	if( !_tested ){	// Test dropdown
		this._testLabelListExists("labels", GIPROTOTYPE.bind(this, function(){this.createLabel(fCallback, _qItem, true)}));
		return;
	}
	
	
	var el = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-labels-create-new");
	GIPROTOTYPE.gmailButtonClick(this._doc, el);
	
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 200 );
}catch(e){ 
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu createLabel\n" + e.toString()) 
}
};





MoreActionsMenu.prototype.getActiveLabels = function(fCallback, _qItem, _tested){
try{
	/*
		Extract 'active' labels for a thread(s) by scanning the label-list and seeing which items are checked.
	*/
	
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.getActiveLabels(fCallback, qItem)} );
		return;
	}
	
	var result = {labels:[]};
	
	if( !_tested ){	// Test label list
		this._testLabelListExists("labels", GIPROTOTYPE.bind(this, function(){this.getActiveLabels(fCallback, _qItem, true)}));
		return;
	}
	
	// Scan the list of labels
	var elList = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-labels");
	for( var i = 0; i < elList.childNodes.length; i++ ){
		var elLi = elList.childNodes[i];
		if( elLi.getAttribute("aria-checked")=="true" ){	// On
			result.labels.push( GIPROTOTYPE.stripTags( elLi.innerHTML ) );
		}
	}
			
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback(result.labels);
		_qItem.release();
	}), 500 );
	
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu getactivelabels\n" + e.toString());
}
};


MoreActionsMenu.prototype.addStar = function(fCallback, noTimeout, _qItem, _tested){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.addStar(fCallback, noTimeout, qItem)} );
		return;
	}
	
	if( !_tested ){	// Test dropdown
		this._testLabelListExists("more-actions", GIPROTOTYPE.bind(this, function(){this.addStar(fCallback, noTimeout, _qItem, true)}));
		return;
	}
	
	var el = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-more-actions-add-star");
	GIPROTOTYPE.gmailButtonClick(this._doc, el);
	
	if( noTimeout ){
		if( fCallback ) fCallback();
		_qItem.release();
	}else{
		setTimeout( GIPROTOTYPE.bind(this, function(){
			if( fCallback ) fCallback();
			_qItem.release();
		}), 750 );
	}
	
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu addStar\n" + e.toString());
}
};
	
MoreActionsMenu.prototype.removeStar = function(fCallback, noTimeout, _qItem, _tested){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.removeStar(fCallback, noTimeout, qItem)} );
		return;
	}
	
	if( !_tested ){	// Test dropdown
		this._testLabelListExists("more-actions", GIPROTOTYPE.bind(this, function(){this.removeStar(fCallback, noTimeout, _qItem, true)}));
		return;
	}
	
	var el = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-more-actions-remove-star");
	GIPROTOTYPE.gmailButtonClick(this._doc, el);
	
	
	if( noTimeout ){
		if( fCallback ) fCallback();
		_qItem.release();
	}else{
		setTimeout( GIPROTOTYPE.bind(this, function(){
			if( fCallback ) fCallback();
			_qItem.release();
		}), 750 );
	}
	
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu removeStar\n" + e.toString());
}
};


MoreActionsMenu.prototype.removeLabels = function(labels, fCallback){
	/*
		Remove a group of labels.
	*/
try{
	if( labels.length > 0 ){
		var labelname = labels.shift();
		this.removeLabel(labelname, GIPROTOTYPE.bind( this, function(){this.removeLabels(labels, fCallback)}));
	}else{
		if( fCallback ) fCallback();
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu removeLabels\n" + e.toString());
}
};


MoreActionsMenu.prototype.markRead = function(fCallback, _qItem, _tested){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.markRead(fCallback, qItem)} );
		return;
	}
	
	if( !_tested ){	// Test dropdown
		this._testLabelListExists("more-actions", GIPROTOTYPE.bind(this, function(){this.markRead(fCallback, _qItem, true)}));
		return;
	}
	
	var el = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-more-actions-mark-read");
	GIPROTOTYPE.gmailButtonClick(this._doc, el);
	
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 500 );
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu markRead\n" + e.toString());
}
};

MoreActionsMenu.prototype.spam = function(fCallback, _qItem, _tested){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.spam(fCallback, qItem)} );
		return;
	}
	
	if( !_tested ){	// Test dropdown
		this._testLabelListExists("move-to", GIPROTOTYPE.bind(this, function(){this.spam(fCallback, _qItem, true)}));
		return;
	}
	
	var el = this._gtdinboxPage.gmailDOM.element("spam-button");
	if( !el ) el = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-move-to-spam");
	GIPROTOTYPE.gmailButtonClick(this._doc, el);
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 500 );
	
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu spam\n" + e.toString());
}
};

MoreActionsMenu.prototype.trash = function(fCallback, _qItem, _tested){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.trash(fCallback, qItem)} );
		return;
	}
	
	if( !_tested ){	// Test dropdown
		this._testLabelListExists("move-to", GIPROTOTYPE.bind(this, function(){this.trash(fCallback, _qItem, true)}));
		return;
	}
	
	
	var el = this._gtdinboxPage.gmailDOM.element("delete-button");
	if( !el ) el = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-move-to-delete");
	GIPROTOTYPE.gmailButtonClick(this._doc, el);
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 500 );
	
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu trash\n" + e.toString());
}
};

MoreActionsMenu.prototype.archive = function(fCallback, _qItem, _tested){
try{
	if( !_qItem ){	// Create a proper queue item
		this._queue.addQueueItem( function(qItem){this.archive(fCallback, qItem)} );
		return;
	}
	
	if( !_tested ){	// Test dropdown
		this._testLabelListExists("more-actions", GIPROTOTYPE.bind(this, function(){this.archive(fCallback, _qItem, true)}));
		return;
	}
	
	var el = this._gtdinboxPage.gmailDOM.element("menu-dropdown-deep-more-actions-archive");
	GIPROTOTYPE.gmailButtonClick(this._doc, el);
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		if( fCallback ) fCallback();
		_qItem.release();
	}), 500 );
	
}catch(e){
	if( _qItem ) _qItem.release();
	if( GTDDEBUGMODE ) alert("MoreActionsMenu archive\n" + e.toString());
}
};


MoreActionsMenu.prototype.runTest = function(verbose){
	// Can be invoked from command line. Assumes something is checked.
try{	
	this._gtdinboxPage.unsafeWindow.console.log( "runTest" );
	var labelsToRemove = [];
	var labelsToAdd = [];
	
	this.doMoreAction(GIPROTOTYPE.bind(this, function(el){
		var title = el.innerHTML.replace(/<.+?>/g, "");
		if( el.getAttribute("act")=="13" ){
			labelsToRemove.push(title);
		}
		if( el.getAttribute("act")=="12" && labelsToAdd.length < 4 ){
			labelsToAdd.push(title);
		}
	}), GIPROTOTYPE.bind(this, function(){
		try{
			this._gtdinboxPage.unsafeWindow.console.log("completed reading labels");
			this._gtdinboxPage.unsafeWindow.console.log(labelsToRemove);
			this._gtdinboxPage.unsafeWindow.console.log(labelsToAdd);
			if( verbose && !confirm("Read Labels. Continue?") ) return;
			this._runTest(labelsToRemove, labelsToAdd, verbose);
		}catch(e){ if( GTDDEBUGMODE ) alert("runTest callback\n" + e.toString()) }
	}))
}catch(e){ if( GTDDEBUGMODE ) alert("runTest\n" + e.toString()) }
};
MoreActionsMenu.prototype._runTest = function(labelsToRemove, labelsToAdd, verbose){
try{
	if( labelsToRemove.length > 0 ){
		if( verbose && !confirm("Going to remove label " + labelsToRemove[0] + ". Continue?") ) return;
		this._gtdinboxPage.unsafeWindow.console.log("removing label: " + labelsToRemove[0] + " (" + labelsToRemove + ")");
		this.removeLabel(labelsToRemove.shift(), GIPROTOTYPE.bind(this, function(){this._runTest(labelsToRemove, labelsToAdd, verbose)}));
	}else if( labelsToAdd.length > 0 ){
		this._gtdinboxPage.unsafeWindow.console.log("adding label: " + labelsToAdd[0] + " (" + labelsToAdd + ")");
		this.addLabel(labelsToAdd.shift(), GIPROTOTYPE.bind(this, function(){this._runTest(labelsToRemove, labelsToAdd, verbose)}));
	}else{
		this._gtdinboxPage.unsafeWindow.console.log("adding star");
		this.addStar( GIPROTOTYPE.bind( this, function(){
			this._gtdinboxPage.unsafeWindow.console.log("removing star");
			this.removeStar( GIPROTOTYPE.bind( this, function(){
				alert("done!");
			}));
		}));
	}
}catch(e){ if( GTDDEBUGMODE ) alert("_runTest\n" + e.toString()) }
};











