/* Copyright Andy Mitchell 2007, 2008. No warranties */

function ShowhiderCombo(gtdinboxPage, id, options){
	this._gtdinboxPage = gtdinboxPage;
	this._id = id;
	this.doc = options.doc || this._gtdinboxPage.doc;
	this.eventObservers = new GtdEventObservers(this);
	this.eventHandlers = new GtdEventHandlers_Mutator(this);
	this.create(options);
	
	
}

ShowhiderCombo.prototype.create = function(options){

try{
	if( !options.type ) options.type = "create";

	this.elTitleTxt = this.doc.createElement("SPAN");
	this.elTriangle = this.doc.createElement("IMG");
	switch( options.type ){
		case "create":
			this.el = this.doc.createElement("DIV");
				this.el.className = "showhider-combo";

			if( options.elParent && options.elBefore ) options.elParent.insertBefore( this.el, options.elBefore );
			else if( options.elParent ) options.elParent.appendChild( this.el );
			
			this.setTitle(options.title);
			this.elTitle = this.doc.createElement("DIV");
			this.elContent = options.elContent;
			this.elContent.style.display = "none";
			this.el.appendChild( this.elTitle );
			this.el.appendChild( this.elContent );
			break;
		case "attach":
			this.el = options.el;
			GIPROTOTYPE.addClassName(this.el, "showhider-combo");
			this.elTitle = GIPROTOTYPE.getElementsByClassName(this.el, options.titleClass)[0];
			if( !this.elTitle ){
				this.elTitle = this.doc.createElement("DIV");
				this.el.appendChild( this.elTitle );
			}
			this.setTitle( this.elTitle.innerHTML.replace(/<.+?>/g,"") );
			this.elTitle.innerHTML = "";
			this.elContent = this.elTitle.nextSibling;
			if( !this.elContent ){
				this.elContent = this.doc.createElement("DIV");
				this.el.appendChild( this.elContent );
			}
			this.elContent.style.display = "none";
			break;
	}
	this.el.style.position = "relative";
	this.elContent.style.position = "absolute";
	this.elTitle.appendChild( this.elTriangle );
	this.elTitle.appendChild( this.elTitleTxt );
	this.elTriangle.src = "chrome://gtdinbox/content/combo.png";
		
	GIPROTOTYPE.addClassName(this.elTitle, "showhider-title");
	GIPROTOTYPE.addClassName(this.elContent, "showhider-content");
	
		
	var elClear = this.doc.createElement("DIV");
		elClear.style.clear = "both";
		elClear.style.height = "1px";
	this.elTitle.appendChild( elClear );
	
	this._show(false);
}catch(e){
	if( GTDDEBUGMODE ) alert("Showhider create\n" + e.toString());
}

};

ShowhiderCombo.prototype.setContent = function(el){
	if( this.elContent ){
		this.elContent.parentNode.insertBefore( el, this.elContent );
		this.elContent.parentNode.removeChild( this.elContent );
	}else{
		this.el.appendChild( el );
	}
	this.elContent = el;
	this.elContent.style.display = "none";
	this.elContent.style.position = "absolute";
	GIPROTOTYPE.addClassName(this.elContent, "showhider-content");
};

ShowhiderCombo.prototype.setTitle = function(t){
	this.elTitleTxt.innerHTML = t;
};

ShowhiderCombo.prototype.show = function(){}

ShowhiderCombo.prototype._show = function(v){
try{
	if( typeof v=="undefined" ){
		return this.elContent.style.display=="";
	}
	if( v && !this._disabled ){
		this.eventObservers.observe(this.doc.body, "mousedown", this._windowClick, false);
		this.eventObservers.stopObserving( this.elTitle, "mousedown", this.mouseDownTitle, true );
		
		
		this.eventHandlers.broadcast("pre-show");
		
		GIPROTOTYPE.addClassName(this.el, "showhider-combo-open");
		
		var borderWidth = this.el? GIPROTOTYPE.getBorderWidth(this.el) : 0;	// get width of el's parent (canvas?) border, which is not included in the cumulativeOffset
		borderWidth = 1;
		var dims = GIPROTOTYPE.getDimensions(this.elTitle);
		this.elContent.style.left = (0 - borderWidth) + "px";
		this.elContent.style.top = dims.height + "px";
				
		this.elContent.style.display = "";
		this.eventHandlers.broadcast("show");
		this.eventHandlers.broadcast("toggle");
	}else{
		this.eventObservers.stopObserving(this.doc.body, "mousedown", this._windowClick, false);
		this.eventObservers.observe( this.elTitle, "mousedown", this.mouseDownTitle, true );
		
		GIPROTOTYPE.removeClassName(this.el, "showhider-combo-open");
		this.elContent.style.display = "none";
		this.eventHandlers.broadcast("hide");
		this.eventHandlers.broadcast("toggle");
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("ShowhiderCombo show\n" + e.toString());
}
};

ShowhiderCombo.prototype.enabled = function(v){
	if( typeof v=="undefined" ) return !this._disabled;
	if( v ){
		GIPROTOTYPE.removeClassName(this.elTitle, "disabled");
		this._disabled = false;
	}else{
		GIPROTOTYPE.addClassName(this.elTitle, "disabled");
		this._show(false);
		this._disabled = true;
	}
};

ShowhiderCombo.prototype._windowClick = function(event){
	if( this._lastShow && ((new Date()).valueOf() - this._lastShow)<750 ) return;	// too soon since shown
	
	if( !GIPROTOTYPE.within( this.elContent, GIPROTOTYPE.pointerX(event), GIPROTOTYPE.pointerY(event) ) ){
		//GIPROTOTYPE.stop(event);
		this._show(false);
	}
};

ShowhiderCombo.prototype.mouseDownTitle = function(event){
	//GIPROTOTYPE.stop(event);
	
	this._lastShow = (new Date()).valueOf();
	this.toggle();
};
ShowhiderCombo.prototype.toggle = function(){
	this._show( !this._show() );
};

ShowhiderCombo.prototype.destroy = function(){
		
	this.eventObservers.destroy();
	this.eventHandlers.destroy();
	this.doc = null;
	this._gtdinboxPage = null;
}