/* Copyright Andy Mitchell 2007, 2008. No warranties */

function ThreadActionsUI(gtdinboxPage, elParent, noCreate){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = this._gtdinboxPage._labels;
	
	this._eventObservers = new GtdEventObservers(this);
	this._eventHandlers = new GtdEventHandlers_Mutator(this);
	
	if( !noCreate ) this._create(elParent);
};

ThreadActionsUI.prototype._create = function(elParent){
	this.el = this._doc.createElement("DIV");
		this.el.className = "thread-actions";
	if( elParent ) elParent.appendChild( this.el );
	
	/*
	var elMarkRead = this._doc.createElement("BUTTON");
		elMarkRead.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.MarkAsRead");	
		this._eventObservers.observe(elMarkRead, "click", this._clickMarkRead, false);
	this.el.appendChild(elMarkRead);
	*/
	
	var elReportSpam = this._doc.createElement("BUTTON");
		elReportSpam.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.ReportSpam");	
		this._eventObservers.observe(elReportSpam, "click", this._reportSpam, false);
	this.el.appendChild(elReportSpam);
	
	var elDelete = this._doc.createElement("BUTTON");
		elDelete.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.Delete");	
		this._eventObservers.observe(elDelete, "click", this._clickDelete, false);
	this.el.appendChild(elDelete);
	
	var elArchive = this._doc.createElement("BUTTON");
		elArchive.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.Archive");	
		this._eventObservers.observe(elArchive, "click", GIPROTOTYPE.bind(this, function(){this._doMarkReadAndArchive(null, true)}), false);
	this.el.appendChild(elArchive);
	
	this.el.appendChild( this.getFinishedButton(true) );
		

};

ThreadActionsUI.prototype.refresh = function(thread){
	this.thread = thread;
};

ThreadActionsUI.prototype.getFinishedButton = function(asRealButton){
	var elFinish = null;
	if( asRealButton ) elFinish = this._doc.createElement("BUTTON");
	else elFinish = this._gtdinboxPage.gmailDOM.createElement("gmail-header-button", this._gtdinboxPage.stringBundle.getString("ThreadActions.Finished"), {'collapseLeft':true, 'collapseRight':true});
		if( asRealButton ) elFinish.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.Finished");	
		elFinish.title = this._gtdinboxPage.stringBundle.getString("ThreadActions.Finished.tooltip");	
		elFinish.style.fontWeight = "bold";
		this._eventObservers.observe(elFinish, "click", this._clickFinish, false);
	return elFinish;
};


ThreadActionsUI.prototype._clickMarkRead = function(event, noClickFinishEvent, callback){
try{
	this._gtdinboxPage._moreActionsMenu.markRead(callback);

	/*
	var f = GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute && el.getAttribute("act")=="1" ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
			return 3;
		}
	});
	
	this._gtdinboxPage._moreActionsMenu.doMoreAction(f, fCallback);
	*/
}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui clickMarkRead\n" + e.toString());
}
};
ThreadActionsUI.prototype._reportSpam = function(event){
	// Can be a bit tigher on the timings, because things rarely run after Archive.
	var el = this._gtdinboxPage.gmailDOM.element("spam-button");
	this._gtdinboxPage._threadListUI.observeScrollTop();
	if( el ){
		GIPROTOTYPE.gmailButtonClick(this._doc, el, "click");
		setTimeout( GIPROTOTYPE.bind(this, function(){
			this._eventHandlers.broadcast("click-finished");
			this._gtdinboxPage._threadListUI.restoreScrollTop();
		}), 250);
	}
};
ThreadActionsUI.prototype._clickArchive = function(event, callback){
try{
	// Can be a bit tigher on the timings, because things rarely run after Archive.
	
	
	var el = this._gtdinboxPage.gmailDOM.element("archive-button");
	if( el ){	// Found button
		GIPROTOTYPE.gmailButtonClick(this._doc, el, "click");
		setTimeout( GIPROTOTYPE.bind(this, function(){
				this._eventHandlers.broadcast("click-finished");
				if( callback ) callback();
			}), 250 );
		
	}else{	// See if in drop down menu
		var fCallback = GIPROTOTYPE.bind(this, function(){
			setTimeout( GIPROTOTYPE.bind(this, function(){	
				this._eventHandlers.broadcast("click-finished");
				if( callback ) callback();
			}), 250);
		});
		this._gtdinboxPage._moreActionsMenu.archive(fCallback);
	}

}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui clickArchive\n" + e.toString());
}
};
ThreadActionsUI.prototype._clickDelete = function(event){
try{
	// Can be a bit tigher on the timings, because things rarely run after Archive.
	fCallback = GIPROTOTYPE.bind(this, function(){
		setTimeout( GIPROTOTYPE.bind(this, function(){
			this._gtdinboxPage._threadListUI.restoreScrollTop();
			this._eventHandlers.broadcast("click-finished");
		}), 100);
	});
	this._gtdinboxPage._threadListUI.observeScrollTop();
	var el = this._gtdinboxPage.gmailDOM.element("delete-button");
	if( el ){
		GIPROTOTYPE.gmailButtonClick(this._doc, el, "click");
		fCallback();
	}else{	// no delete button, could be Sent Mail?
		this._gtdinboxPage._moreActionsMenu.trash();
	}	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui clickDelete\n" + e.toString());
}
};
ThreadActionsUI.prototype._clickFinish = function(event){
try{
	if( !this.thread ){
		alert( this._gtdinboxPage.stringBundle.getString("ThreadActions.Finished.NoThreadError") );
		return;
	}

	var lightbox = null;
	if( this._gtdinboxPage.view("view")=="tl" ){
		lightbox = new GtdLightbox(this._gtdinboxPage, this._gtdinboxPage.doc.body);
		
		var subject = this.thread.subject? (" '" + this.thread.subject + "'") : "";
		lightbox.setType( "processing", {msg:(this._gtdinboxPage.stringBundle.getString("ThreadActions.Finishing") + subject)} );
		lightbox.active(true);
	}
	
	

	// Read useful vars:
	var settingsStatuses = this._gtdinboxPage.settings.labels.types["Statuses"];
	var statusPrefix = settingsStatuses.prefix;
	var statusFinished = settingsStatuses.prefix + settingsStatuses.defaults.Finished;
	
	// Add Status Finished:
	this._gtdinboxPage._threadListUI.observeScrollTop();
	var fCallback = GIPROTOTYPE.bind(this, function(){
		var finalCallback = GIPROTOTYPE.bind(this, function(){
			this._gtdinboxPage._threadListUI.restoreScrollTop();
			if( lightbox ) lightbox.active(false);
		});
		this._doMarkReadAndArchive(finalCallback, null, true);
	});
	this.thread.addLabel( statusFinished, null, "ajax" );
	fCallback();	// Do seperately, as no need to wait or refresh S/Finished
	
	
	/*
	var labels = GIPROTOTYPE.clone(this.thread.labels);
	var hasStatusFinished = false;
	for( var i = 0; i < labels.length; i++ ){	// remove any instance of finished; incase processing after drop down label click has applied a label
		if( labels[i]==statusFinished ){
			hasStatusFinished = true;
			labels.splice(i,1)
			break;
		}
	}
	
	for( var i = 0; i < labels.length; i++ ){
		this._gtdinboxPage.gmailDOM.removeLabelFromThread(this.thread.id, labels[i], null, this.thread);
	}
	
	if( !hasStatusFinished && this._labels.hasLabel(statusFinished) ){	// has S/Finished, so add it
		this._gtdinboxPage.gmailDOM.addLabelToThread(this.thread.id, statusFinished, null, this.thread);
	}
	*/
		
	
	/* PRE DIRECT-CODE METHOD
	
	var labelled = {'count':0};
	var fCallback = GIPROTOTYPE.bind(this, function(act){
		if( --labelled.count==0 ){	// move on
			this._doMarkReadAndArchive(finalCallback);
		}
	});
	if( this._labels.hasLabel(statusFinished) ){	// has S/Finished, so add it
		labelled.count++;
		this._labels.labelThread({labelname:statusFinished, 'on':true, 'threads':this.thread, 'fCallback':fCallback});
	}
	// Remove existing labels:
	for( var i = 0; i < labels.length; i++ ){
		if( labels[i].indexOf(statusPrefix)==0 ){
			labelled.count++;
			this._labels.labelThread({labelname:labels[i], 'on':false, 'threads':this.thread, 'fCallback':fCallback});
		}
	}
	*/

}catch(e){
	if( typeof lightbox!="undefined" && lightbox ) lightbox.active(false);
	if( GTDDEBUGMODE ) alert("threadactionsui clickFinish\n" + e.toString());
}
};
ThreadActionsUI.prototype._doMarkReadAndArchive = function(callback, preserveStar, noScrollChange){
	
try{

	
	if( !noScrollChange ) this._gtdinboxPage._threadListUI.observeScrollTop();
	var markReadAndArchive = GIPROTOTYPE.bind(this, function(){
		this._clickMarkRead(null, true, GIPROTOTYPE.bind(this, function(){	// mark it as read
				this._clickArchive(null, GIPROTOTYPE.bind(this, function(){
					if( !noScrollChange ) this._gtdinboxPage._threadListUI.restoreScrollTop();
					if( callback ) callback();
				}));	//click archive
			}));
	});
	if( !preserveStar && this._gtdinboxPage.settings.labels.starForNextAction ){
		//this._gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false,callback:markReadAndArchive});
		this._gtdinboxPage._moreActionsMenu.removeStar( markReadAndArchive, true );
	}else{
		markReadAndArchive();
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui doMoreReadAndArchive\n" + e.toString());
}
};




ThreadActionsUI.prototype.destroy = function(){
	this._eventHandlers.destroy();
	this._eventObservers.destroy();
};