/* Copyright Andy Mitchell 2007, 2008. No warranties */

function ThreadListUI(gtdinboxPage){
try{
	this.eventObservers = new GtdEventObservers(this);
	this.tlGtdEventObservers = new GtdEventObservers(this);
	this.gtdinboxPage = gtdinboxPage;
	this.doc = gtdinboxPage.doc;
	this._threadList = gtdinboxPage._threadList;
	this._labels = gtdinboxPage._labels;
	//this._threadListPopupUI = gtdinboxPage._threadListPopupUI;
	this._refreshQueue = [];
	//this._autoLabelSeen = {};
	this._multiToOne = new MultiToOne(gtdinboxPage, 250);
	
	this.gtdinboxPage._moreActionsMenu.addEventHandler( this, "actionlist-manual-click", this.manualThreadLabelChange );
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui constructor\n" + e.toString());
}
};

ThreadListUI.prototype.observeScrollTop = function(){
	if( typeof this._currentScrollTop!="undefined" ) return;
	this._currentScrollTop = this.gtdinboxPage.gmailDOM.element("document").documentElement.scrollTop;
};
ThreadListUI.prototype.restoreScrollTop = function(event){

try{
	if( isNaN(this._currentScrollTop) ) return;
	this.gtdinboxPage.gmailDOM.element("window").scrollTo(0, this._currentScrollTop);
	delete this._currentScrollTop;	// make sure it doesn't start jumping after this
}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI restoreScrollTop\n" + e.toString());
}
};

ThreadListUI.prototype.viewChange = function(gmail){
	// Add a column; and update each row.
	
	if( this.listenDOM() ) this.listenDOM(false);
	this.elTL = this.gtdinboxPage.gmailDOM.element("ActiveViewElement", gmail);
	this.listenDOM(true);	
	
	if( !this.gtdinboxPage.settings.ui.hide.removeAllLabels ){
		this.gtdinboxPage._moreActionsMenu.addCustomEntry("tl-removealllabels", this.gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels"), this.gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels.Tooltip"), GIPROTOTYPE.bind(this, this.removeAllLabels));
	}

	this.refresh();
};


ThreadListUI.prototype.getThreadsFromCheckedRows = function(fCallback, forceRefresh){
	// Extract basic row info; as well as checked indices
	// fCallback returns either null or an array of threads
	
	this.uncheckOutOfView();
	
	
	var range = this.gtdinboxPage.gmailDOM.parseElement( "threadlist-range", this.gtdinboxPage.gmailDOM.element("threadlist-range") );
	var search = this.gtdinboxPage.gmailDOM.extractSearchQuery();
	var indices = this.gtdinboxPage.gmailDOM.parseElement("thread-list-index");
	

	
	var row = null;
	if( indices.length==1 ){
		var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-checked-checkbox");
		if( result.snapshotLength > 0 ){
			var elRow = result.snapshotItem(0).parentNode.parentNode;
			var row = this.gtdinboxPage.gmailDOM.parseElement("thread-list-row", elRow);
		}
	}
	
	this.gtdinboxPage._threadList.getThreadFromThreadListUI(row, indices, range, search, fCallback, null, forceRefresh);
};

ThreadListUI.prototype.removeAllLabels = function(){
try{



	this.gtdinboxPage._lightbox.setType("updatingmessages");
	this.gtdinboxPage._lightbox.active(true);
	var fOnDone = GIPROTOTYPE.bind( this, function(){
		this.gtdinboxPage._lightbox.active(false);
	});

	// Get current labels
	var labels = [];
	this.gtdinboxPage._moreActionsMenu.doMoreAction( function(el){
		if( el.getAttribute("act")=="13" ){
			var labelname = el.innerHTML.replace(/\<[^>]+?\>/g, "");
			labels.push( labelname );
		}
	}, GIPROTOTYPE.bind( this, function(){			
		// Remove those labels:
		this.gtdinboxPage._moreActionsMenu.removeLabels(labels, fOnDone);
	}) );











	/*
	this.gtdinboxPage._lightbox.setType("updatingmessages");
	this.gtdinboxPage._lightbox.active(true);
	
	this.getThreadsFromCheckedRows( GIPROTOTYPE.bind( this, function(threads){
	
		try{
			var labelled = {count:0};
			var fOnDone = GIPROTOTYPE.bind(this, function(){
				if( labelled.found ){	// Refresh view since may have removed labels
					setTimeout( GIPROTOTYPE.bind(this.gtdinboxPage.gmailDOM, this.gtdinboxPage.gmailDOM.refreshView), 300 );
				}
				this.gtdinboxPage._lightbox.active(false);
			});
				
			for( var i = 0; i < threads.length; i++ ){
				var thread = threads[i];
			
				labelled.count++;
				if( thread.labels.length > 0 ){
					labelled.found = true;
					thread.removeLabel( GIPROTOTYPE.clone(thread.labels), GIPROTOTYPE.bind(this, function(){
								if( --labelled.count<=0 ){	// Finished
									fOnDone();
								}
							}), "ajax" );
				}
			}
			if( !labelled.found ) fOnDone();
		}catch(e){
			if( GTDDEBUGMODE ) alert( "ThreadListUI  removealllabels search-callback\n" + e.toString() );
		}
	
	}), true);
	*/
}catch(e){
	if( GTDDEBUGMODE ) alert( "ThreadListUI  removealllabels\n" + e.toString() );
}
};

ThreadListUI.prototype.listenDOM = function(v){
	if( typeof v=="undefined" ) return this._listen;
	if( v ){
		if( !this._listen ) this.eventObservers.observe(this.elTL, "DOMNodeInserted", this.domNodeInserted, false);
	}else{
		if( this._listen ) this.eventObservers.stopObserving(this.elTL, "DOMNodeInserted", this.domNodeInserted, false);
	}
	this._listen = v;
};
ThreadListUI.prototype.domNodeInserted = function(event){
	this.listenDOM(false);
	this._multiToOne.process("threadListDomChange", GIPROTOTYPE.bind(this, this.refresh));
};


ThreadListUI.prototype.refresh = function(callback){
	
	if( !this.elTL ) return;
	
	if( this._isRunning ) return;
	this._isRunning = true;
	
	this.listenDOM(false);
	
	
	try{
		this.gtdinboxPage._perfLogger.countCall( "ThreadListUI.refresh" );

		this.tlGtdEventObservers.reset();
		if( !this.gtdinboxPage.settings.ui.hide.rightClick ){
			this.tlGtdEventObservers.observe( this.elTL, "mousedown", this.mouseDown, true);
			this.tlGtdEventObservers.observe( this.elTL, "contextmenu", this.contextMenu, true);
		}


		if( !this.gtdinboxPage.settings.ui.hide.previewIcon ){		
			//var view = this.gtdinboxPage.view();
			
			var elImg = this.doc.createElement("IMG");
			elImg.className = "gtd-row-button";
			elImg.style.position = "absolute";
			if( GTDDEVMODE ){
				elImg.style.right = "12px";
			}else{
				elImg.style.right = "0px";
			}
			elImg.src = "chrome://gtdinbox/content/gtd_lineitem.png";
			elImg.setAttribute("onmouseover", "this.src='chrome://gtdinbox/content/gtd_lineitem-hover.png'");
			elImg.setAttribute("onmouseout", "this.src='chrome://gtdinbox/content/gtd_lineitem.png'");
			elImg.title = this.gtdinboxPage.stringBundle.getString("ThreadListUI.GTDBox.Tooltip");
			
			var elImgBin = this.doc.createElement("IMG");
			elImgBin.className = "gtd-row-bin-button";
			elImgBin.style.position = "absolute";
			elImgBin.style.right = "0px";
			elImgBin.src = "chrome://gtdinbox/content/bin_closed.png";
			elImgBin.setAttribute("onmouseover", "this.src='chrome://gtdinbox/content/bin_closed-hover.png'");
			elImgBin.setAttribute("onmouseout", "this.src='chrome://gtdinbox/content/bin_closed.png'");
			elImgBin.title = this.gtdinboxPage.stringBundle.getString("ThreadListUI.GTDBin.Tooltip");
			
			var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-lastcol"); 
			this.rowCount = result.snapshotLength;
			if( result.snapshotLength>0 ){
				if( (result.snapshotItem(0).innerHTML.indexOf("gtd")==-1 || result.snapshotItem(result.snapshotLength-1).innerHTML.indexOf("gtd")==-1) ){
					for( var i = 0; i < result.snapshotLength; i++ ){
						var elImgC = elImg.cloneNode(true);
						var elImgBinC = elImgBin.cloneNode(true);
						//if( result.snapshotItem(i).innerHTML.indexOf("gtd")==-1 ){
							result.snapshotItem(i).appendChild( elImgC );
							if( GTDDEVMODE ){
								result.snapshotItem(i).appendChild( elImgBinC );
							}
						//}
 					}
				}
			}
			
			
		}
		
		
		if( this.gtdinboxPage._threadListPopupUI.poppedUp() ){	// Precipitate a refresh; used for Create Label (create label causes row update)
			this.gtdinboxPage._threadListPopupUI.labelSelect.refresh();
		}
		
			
	
	}catch(e){
		if( GTDDEBUGMODE ) alert("threadlistui refresh\n" + e.toString())
	}
	this._isRunning = false;
	this.listenDOM(true);
	this.gtdinboxPage._autoLabel.checkAutoLabel();
};


ThreadListUI.prototype.checkRow = function(elCheck, v){
	if( (v && !elCheck.checked) || (!v && elCheck.checked) ){	// invert selection. must use keypress
		GIPROTOTYPE.doMouseEvent( this.doc, elCheck, "click");
	}
};
ThreadListUI.prototype.checkRows = function(a, update){
	// Get or set the status of the rows. 
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-checkbox");
	if( typeof a=="undefined" || !a ){	// return array of checked items
		var a = [];
		for( var i = 0; i < result.snapshotLength; i++ ){
			a[i] = result.snapshotItem(i).checked;
			if( typeof update!="undefined" ) this.checkRow(result.snapshotItem(i), update);
		}
		return a;
	}else{	// check items
		for( var i = 0; i < result.snapshotLength; i++ ){
			this.checkRow(result.snapshotItem(i), (a[i] || false));
		}
	}
};
/*
ThreadListUI.prototype.getCheckedRows = function(){
	var rows = [];
	//var result = this.doc.evaluate( "//div[@gtdviewid='" + this.gtdinboxPage.view("gtdviewid") + "']//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d AnqB9d rfza3e')]//td//input[@type='checkbox']", this.elTL, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-checked-checkbox");
	for( var i = 0; i < result.snapshotLength; i++ ){
		if( result.snapshotItem(i).checked ){
			var row = this.parseRow(result.snapshotItem(i).parentNode.parentNode, i);
			rows.push( row );
		}
	}
	return rows;
};
*/
ThreadListUI.prototype.uncheckOutOfView = function(){
	// Items that remain checked, even when not in view; affect the 'More Actions' drop down
	// Uncheck all checkboxes not currently in view
	// BEWARE: can cause problems on sent items. Checking sent item causes inbox variant to be checked; and unchecking outofview inbox variant consequently unchecks the sent item row.
try{
	var viewid = this.gtdinboxPage.view("gtdviewid");
	//var result = this.doc.evaluate( "//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d AnqB9d rfza3e')]//td//input[@type='checkbox']", this.elTL, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-checked-checkbox");
	for( var i = 0; i < result.snapshotLength; i++ ){
		var el = result.snapshotItem(i);
		if( el.checked ){
			var inview = false;
			while( el.parentNode && el.getAttribute ){
				if( el.getAttribute("gtdviewid")==viewid ){
					inview = true;
					break;
				}
				el = el.parentNode;
			}
			if( !inview ){
				this.checkRow( result.snapshotItem(i), false );
			}
		}
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui uncheckOutOfView\n" + e.toString());
}
};

/*
ThreadListUI.prototype.getRowByThread = function(thread){
try{
	// Scan all rows for a possible match to this thread (row to contain subset of subject, names, snippet).
	//	If possible candidate, reverse lookup the row to see if it returns the thread
	//	If so, return that row
	
	
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-allrows");
	for( var i = 0; i < result.snapshotLength; i++ ){
		var row = new ThreadRow(this, result.snapshotItem(i));
		

		if( thread.testSubject(row.subject) ){
			if( thread.testNames(row.names) ){
				if( thread.testSnippet(row.snippet) ){
					return row;
				}
			}
		}
		
	}	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui getRowByThread\n" + e.toString());
}
};
*/

/*
ThreadListUI.prototype.parseRow = function(elRow, index){
	try{

		var row = new ThreadRow(this, elRow, index);
		return row;
	}catch(e){
		if( GTDDEBUGMODE ) alert("threadlistui parseRow\n" + e.toString());
	}
};
*/
/*
function ThreadRow(threadListUI, elRow, index){
	this._threadListUI = threadListUI;
	this.gtdinboxPage = threadListUI.gtdinboxPage;
	this.index = index;
	this.elRow = elRow;
	this.executeAfterNextPopupRefresh = [];	// A list of functions to execute next time the ThreadListPopupUI refresh function (and callbacks) have completed
	
	var result = this.gtdinboxPage.gmailDOM.parseElement("thread-list-row", elRow);
	GIPROTOTYPE.extend( this, result );
};
ThreadRow.prototype.thread = function(fCallback, forceRefresh, noRefresh){
try{
		var fFirstCallback = GIPROTOTYPE.bind(this, function(thread){
				if( forceRefresh || (!noRefresh && this.messageCount && thread.messageCount < this.messageCount) ){	// Need to force a refresh
					this._threadListUI._threadList.getThreadById( thread.id, fCallback, true );
				}else{
					fCallback(thread); 
				}
			});
		this._threadListUI._threadList.getThreadByRow( this.subject, this.snippet, this.names, GIPROTOTYPE.bind(this, function(thread){
				if( thread ){
					fFirstCallback(thread);
				}else{
					this._threadListUI._threadList.getThreadByRowIndex( GIPROTOTYPE.bind(this, function(thread){
							if( thread ){
								fFirstCallback(thread);
							}else{
								fFirstCallback();
							}
						}) );
				}
				
			}) );
}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadRow thread\n" + e.toString());
}
};
*/

ThreadListUI.prototype.mouseDown = function(event){
	try{
		var el = GIPROTOTYPE.element(event);
		
		if( this.gtdinboxPage.settings.labels.starForNextAction && this.gtdinboxPage.gmailDOM.test("star", el) ){	// It's a star
			// Ensure el points at the row:
			
			var starOn = !this.gtdinboxPage.gmailDOM.test("star-on", el); // (note: inverted due to event timing & icon updating)
			var elRow = el;
			while( !this.gtdinboxPage.gmailDOM.test("thread-row", elRow) && elRow.nodeName!="BODY" ) elRow = elRow.parentNode;
			var elInput = elRow.getElementsByTagName("INPUT")[0];
			var checkedRows = this.checkRows(null, false);
			this.checkRow(elInput, true);
			this.getThreadsFromCheckedRows( GIPROTOTYPE.bind( this, function(threads){
				if( threads && threads.length > 0 ){				
					var status = this.gtdinboxPage.getStatusData();				
					var fCallback = GIPROTOTYPE.bind(this, function(){
						this.checkRows(checkedRows);
						//setTimeout( GIPROTOTYPE.bind( this.gtdinboxPage.gmailDOM, this.gtdinboxPage.gmailDOM.refreshView ), 400 );
					});
					
					if( starOn ){
						threads[0].addLabel( status.NextAction, fCallback, "moreActions", null, true );
					}else{
						threads[0].removeLabel( status.NextAction, fCallback, "moreActions", null, true );
					}
				}else{
					this.checkRows(checkedRows);
				}
			}));
			
			/*
			var gmailDOM = this.gtdinboxPage.gmailDOM;
			var elRow = el;
			while( !gmailDOM.test("thread-row", elRow) && elRow.nodeName!="BODY" ) elRow = elRow.parentNode;
			if( !gmailDOM.test("thread-row", elRow) ) return;
			var row = this.parseRow(elRow);

			row.thread(GIPROTOTYPE.bind(this, function(thread){
				try{
					if( !thread ) return;
					// Check row:
					//this.uncheckOutOfView();
					//var checkedRows = this.checkRows(null, false);
					//this.checkRow(row.elCheck, true);
					// Test to see if star is on/off and respond
					var settings = this.gtdinboxPage.settings;
					var labelNextAction = settings.labels.types.Statuses.prefix + settings.labels.types.Statuses.defaults.NextAction;
					
					var fCallback = GIPROTOTYPE.bind(this, function(){
						//this.checkRows(checkedRows);	// restore
						setTimeout( GIPROTOTYPE.bind( this.gtdinboxPage.gmailDOM, this.gtdinboxPage.gmailDOM.refreshView ), 300 );
					});
					
					if( starOn ){
						thread.addLabel( labelNextAction, fCallback, "ajax", null, true );
					}else{
						thread.removeLabel( labelNextAction, fCallback, "ajax", null, true );
					}
					
				}catch(e){
					if( GTDDEBUGMODE ) alert("ThreadListUI mousedown star row.thread-callback\n" + e.toString());
				}
			}));
			*/
			return;
		}
		
		if( el.className=="gtd-row-button" ){
			GIPROTOTYPE.stop(event);
			var hadLastEventDetail = this._lastEventDetail;
			this._lastEventDetail = event.detail;
			if( !hadLastEventDetail ) setTimeout( GIPROTOTYPE.bind(this, function(){this.gtdIconClick(event,el)}), 400);
		}else if( el.className=="gtd-row-bin-button" ){
			GIPROTOTYPE.stop(event);
			var hadLastEventDetail = this._lastEventDetailBin;
			this._lastEventDetailBin = event.detail;
			if( !hadLastEventDetail ) setTimeout( GIPROTOTYPE.bind(this, function(){this.gtdIconBinClick(event,el)}), 400);
		}else if( event.button==2 ){
			GIPROTOTYPE.stop(event);
		}
	}catch(e){
		if( GTDDEBUGMODE ) alert("threadlistui mouse down\n" + e.toString());
	}
};
ThreadListUI.prototype.gtdIconClick = function(event, el){
try{
	var lastEventDetail = this._lastEventDetail;
	this._lastEventDetail = null;
	
	var elRow = el.parentNode.parentNode;	
	var row = this.gtdinboxPage.gmailDOM.parseElement("thread-list-row", elRow);
	
	if( lastEventDetail==1 ){
		this.popupRow(elRow, el);
	}else{
		this.checkRow(row.elCheck, true);
		this.getThreadsFromCheckedRows( GIPROTOTYPE.bind( this, function(threads){
					var thread = threads[0];
					this.gtdinboxPage._threadListPopupUI.threadActions.refresh(thread);
					if( event.button==0 && !event.shiftKey ){	// Add Label and Archive
						thread.refreshData( GIPROTOTYPE.bind(this, function(){
							var statusData = this.gtdinboxPage.getStatusData();
							thread.addLabel( statusData.Action, GIPROTOTYPE.bind(this, function(){
									this.gtdinboxPage._threadListPopupUI.threadActions._clickArchive(null, GIPROTOTYPE.bind(this, function(){
											this.gtdinboxPage.gmailDOM.refreshView();
										}));
								}), "ajax");
						}));
					}else if( (event.button==0 && event.shiftKey) || event.button==2 ){ // Finish it
						this.gtdinboxPage._threadListPopupUI.threadActions._clickFinish();
					}
		}));
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI gtdIconClick\n" + e.toString());
}
};
ThreadListUI.prototype.gtdIconBinClick = function(event, el){
try{
	var lastEventDetail = this._lastEventDetailBin;
	this._lastEventDetailBin = null;
	
	var elRow = el.parentNode.parentNode;	
	var row = this.gtdinboxPage.gmailDOM.parseElement("thread-list-row", elRow);
	
	this.checkRow(row.elCheck, true);
	//this.getThreadsFromCheckedRows( GIPROTOTYPE.bind( this, function(threads){
	//		this.gtdinboxPage._threadListPopupUI.threadActions.refresh(thread);
			if( lastEventDetail==1 ){
				this.gtdinboxPage._threadListPopupUI.threadActions._doMarkReadAndArchive();
			}else{
				if( event.button==0 && !event.shiftKey ){
					this.gtdinboxPage._threadListPopupUI.threadActions._clickDelete();
				}else if( (event.button==0 && event.shiftKey) || event.button==2 ){
					this.gtdinboxPage._threadListPopupUI.threadActions._reportSpam();
				}
			}
	//}));
	

}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI gtdIconClick\n" + e.toString());
}
};

ThreadListUI.prototype.contextMenu = function(event){
try{
	GIPROTOTYPE.stop(event);
	var el = GIPROTOTYPE.element(event);
	
	if( el.className=="gtd-row-button" || el.className=="gtd-row-bin-button" ) return;
	
	// Ensure el points at the row:
	var gmailDOM = this.gtdinboxPage.gmailDOM;
	while( !gmailDOM.test("thread-row", el) && el.nodeName!="BODY" ) el = el.parentNode;
	if( !gmailDOM.test("thread-row", el) ) return;
	
	this.popupRow(el, event, {location: "bottomLeft", margin: 15, scrollToView:true} );

}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI contextMenu\n" + e.toString());
}
};


ThreadListUI.prototype.popupRow = function(elRow, popupType, popupOptions){
try{
	this.gtdinboxPage._threadListPopupUI.popupOff();	// clear out checked rows
	
	
	var row = this.gtdinboxPage.gmailDOM.parseElement("thread-list-row", elRow);
	this.gtdinboxPage._threadListPopupUI.popup( popupType, popupOptions );
	this.gtdinboxPage._threadListPopupUI.loading(true);
	this.uncheckOutOfView();
	this.checkRow(row.elCheck, true);
	this.getThreadsFromCheckedRows( GIPROTOTYPE.bind( this, function(threads){
		try{
			if( !threads || threads.length==0 ) return;
					
			setTimeout( GIPROTOTYPE.bind(this, function(){
				this.gtdinboxPage._threadListPopupUI.load( threads[0] );
			}), 5 );
		}catch(e){
			if( GTDDEBUGMODE ) alert("ThreadListUI popupRow callback\n" + e.toString());
		}
		//this.gtdinboxPage._threadListPopupUI.setRow( row );	// Something to do with the stack originating from the context-event, and later hitting a .apply, was causing heavy cyclical problems
	}));
	
	
	/*
	var row = this.parseRow(elRow);
	this.gtdinboxPage._threadListPopupUI.popup( popupType, popupOptions );
	this.uncheckOutOfView();
	this.checkRow(row.elCheck, true);
	
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		this.gtdinboxPage._threadListPopupUI.loadByRow( row, true );
		}), 5 );
	//this.gtdinboxPage._threadListPopupUI.setRow( row );	// Something to do with the stack originating from the context-event, and later hitting a .apply, was causing heavy cyclical problems
	*/
}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI popupRow\n" + e.toString());
}
};






ThreadListUI.prototype.manualThreadLabelChange = function(event, label){

try{
	if( this.gtdinboxPage.view("view")!="tl" ) return;	// i should be active view
	
	var status = this.gtdinboxPage.getStatusData();
	var onlyOneStatus = this.gtdinboxPage.settings.labels.onlyOneStatus;


	
	this.gtdinboxPage._lightbox.setType("updatingmessages");
	this.gtdinboxPage._lightbox.active(true);
	var fOnDone = GIPROTOTYPE.bind( this, function(){
		this.gtdinboxPage._lightbox.active(false);
	});

	if( label.act=="12" ){
		if( this.gtdinboxPage.settings.labels.onlyOneStatus && label.safelabel.indexOf(status.prefix)==0 ){
			// Get current labels
			
			var hadNextAction = false;				
			this.gtdinboxPage._moreActionsMenu.getActiveLabels( GIPROTOTYPE.bind(this, function(labels){
					// labels contains all active status labels; refine them to status labels
					for( var i = labels.length - 1; i >= 0; i-- ){
						if( labels[i]==label.safelabel || labels[i].indexOf(status.prefix)!=0 ){
							labels.splice(i,1);
						}else{
							if( labels[i]==status.NextAction ) hadNextAction = true;
						}
					}
					// Remove the remaining Status labels labels:
					this.gtdinboxPage._moreActionsMenu.removeLabels(labels, GIPROTOTYPE.bind(this, function(){
						this._mtAdd_ChangeStar(label, hadNextAction, GIPROTOTYPE.bind( this, function(){
							this._mtAdd_Archive( label, fOnDone );
						}) );
					}));
				}));
									
		}else{
			this._mtAdd_Archive( label, fOnDone );
		}
	}else if( label.act=="13" ){
		if( this.gtdinboxPage.settings.labels.starForNextAction && status.NextAction==label.safelabel ){	// It's removing a next action; remove star
			var f = GIPROTOTYPE.bind(this, function(){
				//this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false, callback:fOnDone});
				this.gtdinboxPage._moreActionsMenu.removeStar(fOnDone);
			});
			setTimeout(f, 100);
		}else{
			fOnDone();
		}
	}
	
	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui manualThreadLabelChange\n" + e.toString());
}
};

ThreadListUI.prototype._mtAdd_ChangeStar = function(label, hadNextAction, fCallback){
try{
	var status = this.gtdinboxPage.getStatusData();
	if( this.gtdinboxPage.settings.labels.starForNextAction ){
		if( label.safelabel==status.NextAction ){
			//this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:true, callback: fCallback});
			this.gtdinboxPage._moreActionsMenu.addStar( fCallback );
		}else if( hadNextAction ){
			//this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false, callback: fCallback});
			setTimeout( GIPROTOTYPE.bind(this, function(){
				this.gtdinboxPage._moreActionsMenu.removeStar(fCallback);
			}), 600);
		}else{
			if( fCallback ) fCallback();
		}
	}else{
		if( fCallback ) fCallback();
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui _mtAdd_ChangeStar\n" + e.toString());
}
};
ThreadListUI.prototype._mtAdd_Archive = function(label, fCallback){
try{
	var status = this.gtdinboxPage.getStatusData();
	if( status.Finished==label.safelabel || label.doArchive ){
		var threadActionsUI = new ThreadActionsUI(this.gtdinboxPage, null, true);
		threadActionsUI._doMarkReadAndArchive(fCallback);
	}else{
		if( fCallback ) fCallback();
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui _mtAdd_Archive\n" + e.toString());
}
};
ThreadListUI.prototype._mt_syncThreads = function(label, fCallback){
try{
	this.getThreadsFromCheckedRows( GIPROTOTYPE.bind(this, function(threads){
		if( label.act=="12" ){
			for( var i = 0; i < threads.length; i++ ) threads[i].addLabel(label.label, null, null, true);
		}else if( label.act=="13" ){
			for( var i = 0; i < threads.length; i++ ) threads[i].removeLabel(label.label, null, null, true);
		}
		if( fCallback ) fCallback();
	}) );
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui _mt_syncThreads\n" + e.toString());
}
};









/*
ThreadListUI.prototype.manualThreadLabelChange = function(event, label){
	// Called when user manually selects label on drop down
	// Kept seperate from Labels because ThreadList/Conversation would handle it differently

try{
	if( this.gtdinboxPage.view("view")!="tl" ) return;	// i should be active view
	
	 
	var status = this.gtdinboxPage.getStatusData();
	var onlyOneStatus = this.gtdinboxPage.settings.labels.onlyOneStatus;
			
	this.getThreadsFromCheckedRows( GIPROTOTYPE.bind(this, function(threads){	// Get fully refresh rows
		try{
			if( label.safelabel.indexOf( status.prefix )==0 ){	// Status
			
				if( label.act=="12" ){
				
					var f = GIPROTOTYPE.bind(this, function(){
						this.gtdinboxPage._lightbox.setType("updatingmessages");
						this.gtdinboxPage._lightbox.active(true);
						
						var threadActionsUI = new ThreadActionsUI(this.gtdinboxPage, null, true);
						var labelled = {count:0};
						var fOnDone = GIPROTOTYPE.bind(this, function(){
								var fOnDone2 = GIPROTOTYPE.bind(this, function(){
										if( labelled.found ){	// Refresh view since may have removed labels
											this.gtdinboxPage.gmailDOM.refreshView();
										}
										this.gtdinboxPage._lightbox.active(false);
									});

								if( this.gtdinboxPage.settings.labels.starForNextAction ){	// It's a Next Action, add a star
									if( status.NextAction==label.safelabel ){
										this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:true, callback: fOnDone2});
									}else{
										this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false, callback: fOnDone2});
									}
								}
								if(status.Finished==label.safelabel){
									threadActionsUI._doMarkReadAndArchive(fOnDone2); // Archive it
								}else{
									fOnDone2();
								}		
							});
						
						if( status.Finished==label.safelabel || onlyOneStatus ){	// remove non-current status labels									
								for( var i = 0; i < threads.length; i++ ){
									var thread = threads[i];									
								
									for( var j = 0; j < thread.labels.length; j++ ){
										if( thread.labels[j].indexOf(this.gtdinboxPage.settings.labels.types.Statuses.prefix)==0 && thread.labels[j]!=label.safelabel ){
											var l = thread.labels[j];
											labelled.count++;
											labelled.found = true;
										
											this.gtdinboxPage.gmailDOM.removeLabelFromThread(thread.id, l, GIPROTOTYPE.bind(this, function(){
													if( --labelled.count<=0 ){	// Finished
														fOnDone();
													}
												}), thread);
											thread.removeLabel(l, null, null, true);												
										}
									}
								}
								if( !labelled.found ) fOnDone();
						}else{
							fOnDone();
						}

						for( var i = 0; i < threads.length; i++ ) threads[i].addLabel(label.label, null, null, true);
					});
					setTimeout(f, 100);
				
				}else if( label.act=="13" ){
					if( this.gtdinboxPage.settings.labels.starForNextAction && status.NextAction==label.safelabel ){	// It's removing a next action; remove star
						var f = GIPROTOTYPE.bind(this, function(){
							this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false});
						});
						setTimeout(f, 100);
					}
					for( var i = 0; i < threads.length; i++ ) threads[i].removeLabel(label.label, null, null, true);
				}
			
			}
		}catch(e){
			if( GTDDEBUGMODE ) alert("threadlistui manualThreadLabelChange callback\n" + e.toString());
		}
	}), true);
	
	*/
	/*
	var rows = this.getCheckedRows();	
	if( rows.length==0 ) return;
		
	//if( !label.safelabel.indexOf( this.gtdinboxPage.settings.labels.types.Projects.prefix )==0 ) return;
	
	
	var statusPrefix = this.gtdinboxPage.settings.labels.types.Statuses.prefix;
	var statusNextAction = statusPrefix + this.gtdinboxPage.settings.labels.types.Statuses.defaults.NextAction;
	var statusFinished = statusPrefix + this.gtdinboxPage.settings.labels.types.Statuses.defaults.Finished;
	var onlyOneStatus = this.gtdinboxPage.settings.labels.onlyOneStatus;
	
	if( label.act=="12" && label.safelabel.indexOf( statusPrefix )==0 ){
		// It's a status label; and rules may apply that dictate only one status can exist at once
		// The problem is that theres no guarentee each selected row's thread object is synced with the labels on that item
		// So, need to process each selected row, and verify labels
		// If Finished, remove all non-finished labels then mark as read & archive
		// If only one status, remove all non-finished labels
		var f = GIPROTOTYPE.bind(this, function(){
				this.gtdinboxPage._lightbox.setType("updatingmessages");
				this.gtdinboxPage._lightbox.active(true);
				
				var range = this.gtdinboxPage.gmailDOM.parseElement( "threadlist-range", this.gtdinboxPage.gmailDOM.element("threadlist-range") );
				var searchStr = this.gtdinboxPage.gmailDOM.extractSearchQuery();
				var threadList = new ThreadList(this.gtdinboxPage);
							
				this.gtdinboxPage.gmailDOM.search(searchStr, threadList, range.start, range.end - range.start, GIPROTOTYPE.bind(this, function(searchArray, query, threadList, currentOffset){
						threadList.parseAjaxResponse(searchArray[0]);
						var rowIndices = this.gtdinboxPage.gmailDOM.parseElement("thread-list-index");
						
						var threadActionsUI = new ThreadActionsUI(this.gtdinboxPage, null, true);


						var labelled = {count:0};
						var fOnDone = GIPROTOTYPE.bind(this, function(){
								var fOnDone2 = GIPROTOTYPE.bind(this, function(){
										if( labelled.found ){	// Refresh view since may have removed labels
											this.gtdinboxPage.gmailDOM.refreshView();
										}
										this.gtdinboxPage._lightbox.active(false);
									});
																		
								if( this.gtdinboxPage.settings.labels.starForNextAction ){	// It's a Next Action, add a star
									if( statusNextAction==label.safelabel ){
										this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:true, callback: fOnDone2});
									}else{
										this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false, callback: fOnDone2});
									}
								}
								if(statusFinished==label.safelabel){
									threadActionsUI._doMarkReadAndArchive(fOnDone2); // Archive it
								}else{
									fOnDone2();
								}		
							});
						
						if( statusFinished==label.safelabel || onlyOneStatus ){	// remove non-current status labels		
							
							// Deep load threads for faster label removal
							var threadIds = [];
							for( var i = 0; i < rowIndices.length; i++ ){
								threadIds.push( threadList._threads[rowIndices[i]].id );
							}
							this.gtdinboxPage.gmailDOM.getThreadData(threadIds, threadList, GIPROTOTYPE.bind( this, function(){
								
															
								for( var i = 0; i < rowIndices.length; i++ ){
									var thread = threadList._threads[rowIndices[i]];									
								
									for( var j = 0; j < thread.labels.length; j++ ){
										if( thread.labels[j].indexOf(this.gtdinboxPage.settings.labels.types.Statuses.prefix)==0 && thread.labels[j]!=label.safelabel ){
											var l = thread.labels[j];
											labelled.count++;
											labelled.found = true;

											
											this.gtdinboxPage.gmailDOM.removeLabelFromThread(thread.id, l, GIPROTOTYPE.bind(this, function(){
													if( --labelled.count<=0 ){	// Finished
														fOnDone();
													}
												}), thread);
											thread.removeLabel(l, null, null, true);
											
										}
									}
									
								}
								
								if( !labelled.found ) fOnDone();
							}));
						}else{
							fOnDone();
						}					
						
					}));
				
			});
		setTimeout(f, 100);
	}else if( label.act=="13" && label.safelabel.indexOf( statusPrefix )==0 ){
		if( this.gtdinboxPage.settings.labels.starForNextAction && statusNextAction==label.safelabel ){	// It's removing a next action; remove star
			var f = GIPROTOTYPE.bind(this, function(){
				this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false});
			});
			setTimeout(f, 100);
		}
	}
	
	// Sync the threads
	
	for( var i = 0; i < rows.length; i++ ){
		//var thread = rows[i].thread();
		
		rows[i].thread( GIPROTOTYPE.bind( this, function(thread){		
			if( thread ){
				if( label.act=="12" ){
					var f = function(){					
						thread.addLabel(label.label, null, null, true);
					}
					setTimeout(f, 200);
				}else{
					thread.removeLabel(label.label, null, null, true);
				}
			}
		}));
		
	}
	
	*/
	
/*
	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui manualThreadLabelChange\n" + e.toString());
}
};
*/

ThreadListUI.prototype.destroy = function(){
	this._isRunning = true;
	this._refreshQueue.length = 0;
	this.eventObservers.destroy();
	this.tlGtdEventObservers.destroy();
	this._multiToOne.destroy();
};