/* Copyright Andy Mitchell 2007, 2008. No warranties */

/*
If actions happen in rapid succession; process only the first one (and execute after timeout).
*/

function MultiToOne(gtdinboxPage, timeDelay){
	this._gtdinboxPage = gtdinboxPage;
	this._timeDelay = timeDelay || 500;
	
	this._inProgress = {};	// this._inProgress[key] = {date, function}
};

MultiToOne.prototype.process = function(key, f){
try{
	if( this._inProgress[key] ) return;
	
	this._inProgress[key] = {date: (new Date()).valueOf(), callback: f};
	setTimeout( GIPROTOTYPE.bind(this, function(){this._handle(key)}), this._timeDelay );
}catch(e){
	if( GTDDEBUGMODE ) alert("MultiToOne process\n" + e.toString());
}
};

MultiToOne.prototype._handle = function(key){
try{
	if( !this._gtdinboxPage ) return;	// destroyed
	if( !this._inProgress[key] ) return;
	if( this._inProgress[key].callback ) this._inProgress[key].callback();
	this._inProgress[key] = null;
	delete this._inProgress[key];
}catch(e){
	if( GTDDEBUGMODE ) alert("MultiToOne _handle\n" + e.toString());
}
};

MultiToOne.prototype.remove = function(key){
	if( this._inProgress[key] ) delete this._inProgress[key];
};

MultiToOne.prototype.destroy = function(){
	this._gtdinboxPage = null;
};